SystemOrganization addCategory: #'XPath-Core'!
SystemOrganization addCategory: 'XPath-Core-Compilation'!
SystemOrganization addCategory: 'XPath-Core-DOM'!
SystemOrganization addCategory: 'XPath-Core-Exceptions'!
SystemOrganization addCategory: 'XPath-Core-Functions'!
SystemOrganization addCategory: 'XPath-Core-Parsers'!
SystemOrganization addCategory: 'XPath-Core-Streams'!

!String class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathString! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/17/2014 14:19'!
asXPath
	^ XPath for: self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 11/20/2015 20:35'!
asXPathAttributeNodeTestBlock
	"parses string as a node test to produce a node test block where attributes
	are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler withAttributePrincipalNodeType) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self notEmpty! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:47'!
asXPathComparable
	^ XPathStringComparable value: self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 11:14'!
asXPathFilterable
	XPathTypeException signal: 'Cannot filter strings'! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:43'!
asXPathLocationPathRoot
	XPathTypeException signal: 'Cannot use strings as location path roots'! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 11/20/2015 20:36'!
asXPathNamespaceNodeTestBlock
	"parses string as a node test to produce a node test block where namespaces
	are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler withNamespacePrincipalNodeType) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:46'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert strings to node sets'! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 10/29/2015 17:01'!
asXPathNodeSetFilters
	^ #()! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 11/20/2015 20:36'!
asXPathNodeTestBlock
	"parses string as a node test to produce a node test block"
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler withElementPrincipalNodeType) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 4/7/2015 09:07'!
asXPathNumber
	^ Number xPathReadFrom: self readStream! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 15:06'!
asXPathString
	^ self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:19'!
asXPathUnionable
	XPathTypeException signal: 'Cannot union strings'! !

!String methodsFor: '*XPath-Core-testing' stamp: 'monty 10/29/2015 17:00'!
hasXPathNodeSetFilters
	^ false! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 10/29/2015 17:00'!
asXPathAttributeNodeTestBlock
	^ self! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 9/4/2016 01:42'!
asXPathFilterable
	"assume the receiver is some kind of node test block"
	^ XPathNodeTestWithFilters nodeTest: self! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 10/29/2015 17:00'!
asXPathNamespaceNodeTestBlock
	^ self! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 10/29/2015 17:01'!
asXPathNodeSetFilters
	^ #()! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 10/29/2015 17:00'!
asXPathNodeTestBlock
	^ self! !

!BlockClosure methodsFor: '*XPath-Core-testing' stamp: 'monty 10/29/2015 17:00'!
hasXPathNodeSetFilters
	^ false! !

!Collection methodsFor: '*XPath-Core-converting' stamp: 'monty 3/6/2016 14:42'!
asXPathFunctionSet
	^ XPathFunctionSet withAll: self! !

Collection subclass: #XPathFunctionSet
	instanceVariableNames: 'functionsByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFunctionSet commentStamp: 'monty 2/10/2015 03:01' prior: 0!
A set for XPath functions. Supports set composition with + and - and lookup of functions by name.
!

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 3/8/2015 11:44'!
default
	^ XPathBooleanFunction +
		XPathCeilingFunction +
		XPathConcatFunction +
		XPathContainsFunction +
		XPathCountFunction +
		XPathEndsWithFunction +
		XPathFalseFunction +
		XPathFloorFunction +
		XPathIDFunction +
		XPathLangFunction +
		XPathLocalNameFunction +
		XPathNameFunction +
		XPathNamespaceURIFunction +
		XPathNormalizeSpaceFunction +
		XPathNotFunction +
		XPathNumberFunction +
		XPathRoundFunction +
		XPathStartsWithFunction +
		XPathStringFunction +
		XPathStringLengthFunction +
		XPathSubstringAfterFunction +
		XPathSubstringBeforeFunction +
		XPathSubstringFunction +
		XPathSumFunction +
		XPathTranslateFunction +
		XPathTrueFunction! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/18/2015 15:23'!
new
	^ self new: 15! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 12/27/2014 17:02'!
new: aCapacity
	^ self basicNew initialize: aCapacity! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 3/6/2016 14:41'!
newFrom: aCollection
	"for GS portability"
	^ self withAll: aCollection! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 3/6/2016 14:40'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asXPathFunctionSetWithFunctions: self! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 9/28/2016 22:39'!
, aCollection
	"GS doesn't define #, for non-Sequenceable collections"
	^ self copy
		addAll: aCollection;
		yourself! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 3/6/2016 14:39'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asXPathFunctionSetSubtractedFromFunctions: self! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 11/18/2015 05:17'!
= aFunctionSet
	self == aFunctionSet
		ifTrue: [^ true].

	(self species == aFunctionSet species
		and: [self size = aFunctionSet size])
		ifFalse: [^ false].

	^ self allSatisfy: [:each | aFunctionSet includes: each].! !

!XPathFunctionSet methodsFor: 'adding' stamp: 'monty 12/27/2014 16:56'!
add: aFunction
	^ functionsByName
		at: aFunction functionName
		put: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSet
	^ self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asXPathFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetWithFunction: aFunction
	^ self copyWith: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:40'!
asXPathFunctionSetWithFunctions: aFunctionSet
	^ self, aFunctionSet! !

!XPathFunctionSet methodsFor: 'enumerating' stamp: 'monty 12/27/2014 16:59'!
do: aBlock
	functionsByName valuesDo: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 11/18/2015 05:25'!
functionNamed: aFunctionName
	^ self
		functionNamed: aFunctionName
		ifAbsent: [nil]! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 11/18/2015 05:18'!
functionNamed: aFunctionName ifAbsent: aBlock
	^ functionsByName
		at: aFunctionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'private' stamp: 'monty 1/19/2015 17:08'!
functionsByName
	^ functionsByName! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 12/29/2014 21:19'!
hash
	^ functionsByName hash! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 12/27/2014 17:10'!
includes: aFunction
	^ (functionsByName
		at: aFunction functionName
		ifAbsent: [^ false]) == aFunction! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 2/10/2015 19:15'!
includesFunctionNamed: aName
	^ functionsByName includesKey: aName! !

!XPathFunctionSet methodsFor: 'initialization' stamp: 'monty 12/27/2014 17:01'!
initialize: aCapacity
	functionsByName := Dictionary new: aCapacity! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 12/27/2014 03:55'!
postCopy
	functionsByName := functionsByName copy! !

!XPathFunctionSet methodsFor: 'removing' stamp: 'monty 12/27/2014 16:58'!
remove: aFunction ifAbsent: aBlock
	^ functionsByName
		removeKey: aFunction functionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'removing' stamp: 'monty 4/2/2016 01:52'!
removeAll
	"Redefined because Collection>>removeAll assumes the collection can
	be safely modified while iterating it with do:"

	functionsByName removeAll! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 12/27/2014 03:59'!
size
	^ functionsByName size! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-enumerating' stamp: 'monty 1/16/2015 14:20'!
allNodesReverseDo: aBlock
	self hasChildren
		ifTrue: [self nodes reverseDo: [:each | each allNodesReverseDo: aBlock]].
	aBlock value: self.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:48'!
childAxisSelect: aNodeTestBlock into: aNodeSet
	self hasChildren
		ifTrue: [| nodeList |
			"use to:do: with direct access for speed"
			nodeList := self nodes.
			1 to: nodeList size do: [:i | | node |
				node := nodeList at: i.
				(aNodeTestBlock value: node)
					ifTrue: [aNodeSet addLast: node]]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/27/2016 13:38'!
descendantAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	self descendantNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/27/2016 13:38'!
descendantAxisSelect: aNodeTestBlock into: aNodeSet
	self descendantNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:32'!
descendantOrSelfAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	self allNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:49'!
descendantOrSelfAxisSelect: aNodeTestBlock into: aNodeSet
	self allNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!Boolean class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:47'!
asXPathComparable
	^ XPathBooleanComparable value: self! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 11:15'!
asXPathFilterable
	XPathTypeException signal: 'Cannot filter booleans'! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:43'!
asXPathLocationPathRoot
	XPathTypeException signal: 'Cannot use booleans as location path roots'! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:45'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert booleans to node sets'! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 17:29'!
asXPathNumber
	"Gemstone has TrueClass/FalseClass instead of True/False subclasses,
	so this is implemented in the superclass for portability"
	^ self
		ifTrue: [1.0]
		ifFalse: [0.0]! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 17:28'!
asXPathString
	"Gemstone has TrueClass/FalseClass instead of True/False subclasses,
	so this is implemented in the superclass for portability"
	^ self
		ifTrue: ['true']
		ifFalse: ['false']! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:18'!
asXPathUnionable
	XPathTypeException signal: 'Cannot union booleans'! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 13:50'!
/ aStringOrBlockOrNodeTestWithFilters
	"redefined here to prevent a conflicting method from the Pastell project
	from shadowing the inherited implementation if Pastell was installed"
	^ self childAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 13:51'!
// aStringOrBlockOrNodeTestWithFilters
	"redefined here to prevent a conflicting method from the Pastell project
	from shadowing the inherited implementation if Pastell was installed"
	^ self descendantAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNodeWithElements methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	"spec says the string-value of documents and elements is all text
	descendants concatenated, so contentString can't be used because it
	inserts spaces"
	^ self rawContentString! !

!Stream methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 05:49'!
asXPathReadStreamAdapter
	^ XPathReadStreamAdapter on: self! !

!Stream methodsFor: '*XPath-Core-private' stamp: 'monty 3/12/2016 19:09'!
xPathSkipSeparators
	"provides consistent cross-platform separator skipping with the XML set of
	separators"
	[self atEnd not
		and: [self peek isXMLSeparator]]
		whileTrue: [self next]! !

!XMLString methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self string! !

XMLNodeList subclass: #XPathNodeSet
	instanceVariableNames: 'set sortOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNodeSet commentStamp: 'monty 10/7/2015 05:57' prior: 0!
This class is an ordered node list that has no duplicates.!

!XPathNodeSet class methodsFor: 'instance creation' stamp: 'monty 4/15/2015 11:47'!
new
	^ self new: 10! !

!XPathNodeSet class methodsFor: 'instance creation' stamp: 'monty 10/28/2015 14:24'!
xPathNewFrom: anObject
	^ anObject asXPathNodeSet! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:42'!
% aStringOrBlockOrNodeTestWithFilters
	^ self parentAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:42'!
%% aStringOrBlockOrNodeTestWithFilters
	^ self ancestorAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:43'!
%%~ aStringOrBlockOrNodeTestWithFilters
	^ self ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
& aNodeSet
	"redefined here for portability"
	^ self intersection: aNodeSet! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:43'!
/ aStringOrBlockOrNodeTestWithFilters
	^ self childAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:44'!
// aStringOrBlockOrNodeTestWithFilters
	^ self descendantAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:44'!
//~ aStringOrBlockOrNodeTestWithFilters
	^ self descendantOrSelfAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:44'!
<< aStringOrBlockOrNodeTestWithFilters
	^ self precedingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:45'!
<<< aStringOrBlockOrNodeTestWithFilters
	^ self precedingSiblingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:47'!
>> aStringOrBlockOrNodeTestWithFilters
	^ self followingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:47'!
>>> aStringOrBlockOrNodeTestWithFilters
	^ self followingSiblingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:48'!
@ aStringOrBlockOrNodeTestWithFilters
	^ self attributeAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:48'!
@@ aStringOrBlockOrNodeTestWithFilters
	^ self namespaceAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
\ aNodeSet
	"redefined here for portability"
	^ self difference: aNodeSet! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/6/2016 21:06'!
addAllIfNotPresentTo: aCollection
	"this inverts addAll: because addAll: uses do: because its arg may not
	be a SequenceableCollection and may not understand to:do:, but to:do:
	is needed for speed, and an includes: test avoids adding an already
	present element to the end of a node set which requires left shifting
	everything after it by one"
	1 to: self size do: [:i | | node |
		node := self at: i.
		(aCollection includes: node)
			ifFalse: [aCollection addLast: node]]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/6/2016 21:06'!
addAllTo: aCollection
	"this inverts addAll: because addAll: uses do: because its arg may not
	be a SequenceableCollection and may not understand to:do:, but to:do:
	is needed for speed"
	1 to: self size do: [:i | aCollection addLast: (self at: i)]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAdding: aNode at: anIndex
	| oldSize |

	sortOrder := nil.
	oldSize := self set size.
	(self set
		add: aNode;
		size) = oldSize
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: anIndex]
		ifFalse: [
			observer
				ifNotNil: [observer addedNode: aNode]].! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAddingLast: aNode
	| oldSize |

	sortOrder := nil.
	oldSize := self set size.
	(self set
		add: aNode;
		size) = oldSize
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: oldSize]
		ifFalse: [
			observer
				ifNotNil: [observer addedNode: aNode]]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 8/30/2016 18:26'!
afterRemoving: aNode
	"removing does not change order, so sortOrder is not reset here"
	self set remove: aNode.
	observer
		ifNotNil: [observer removedNode: aNode].! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:42'!
ancestorAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		ancestorAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:43'!
ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathBoolean
	^ self notEmpty! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 2/22/2016 11:05'!
asXPathComparable
	^ XPathNodeSetComparable value: self! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 2/23/2016 08:22'!
asXPathFilterable
	^ self sorted! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 10/29/2015 14:55'!
asXPathLocationPathRoot
	^ self! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 10/27/2015 17:37'!
asXPathNodeSet
	^ self! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathNumber
	^ self asXPathString asXPathNumber! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 3/25/2015 20:44'!
asXPathString
	^ self firstInDocumentOrder
		ifNil: ['']
		ifNotNil: [:node | node stringValue]! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 2/22/2016 10:19'!
asXPathUnionable
	^ self! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:48'!
attributeAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		attributeAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:43'!
childAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		childAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copy
	"copies that don't add or replace keep sort order"
	^ super copy sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copyAfter: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyAfter: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copyAfterLast: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyAfterLast: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copyFrom: aStartIndex to: anEndIndex
	"copies that don't add or replace keep sort order"
	^ (super
		copyFrom: aStartIndex
		to: anEndIndex) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:35'!
copyUpTo: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyUpTo: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:35'!
copyUpToLast: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyUpToLast: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:35'!
copyWithout: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyWithout: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copyWithoutAll: aCollection
	"copies that don't add or replace keep sort order"
	^ (super copyWithoutAll: aCollection) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:44'!
descendantAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		descendantAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:44'!
descendantOrSelfAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		descendantOrSelfAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:35'!
difference: aNodeSet
	^ (self copyWithoutAll: aNodeSet) sort! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 10/8/2015 08:49'!
filterEachInSeparateContextWith: aThreeArgumentBlockOrNumber
	| copy |

	aThreeArgumentBlockOrNumber isNumber
		ifTrue: [
			aThreeArgumentBlockOrNumber rounded = 1
				ifTrue: [copy := self]
				ifFalse: [copy := self copyEmpty]]
		ifFalse: [
			copy := self copyEmpty.
			1 to: self size do: [:i | | node result |
				node := self at: i.
				(result :=
					aThreeArgumentBlockOrNumber
						value: node
						value: 1
						value: 1) isNumber
						ifTrue: [
							result rounded = 1
								ifTrue: [copy addLast: node]]
						ifFalse: [
							result asXPathBoolean
								ifTrue: [copy addLast: node]]]].
	"filtering cannot change the sort order"
	^ copy sortOrderFrom: self.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 10/11/2015 03:57'!
filterEachInSeparateContextWithAll: aFilterCollection
	| filteredNodeSet |

	filteredNodeSet := self.
	"to:do: for speed"
	1 to: aFilterCollection size do: [:i |
		filteredNodeSet isEmpty
			ifTrue: [^ filteredNodeSet].
		filteredNodeSet :=
			filteredNodeSet filterEachInSeparateContextWith:
				(aFilterCollection at: i)].
	^ filteredNodeSet.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 10/7/2015 22:30'!
filterWith: aThreeArgumentBlockOrNumber
	| copy |

	copy := self copyEmpty.
	aThreeArgumentBlockOrNumber isNumber
		ifTrue: [
			copy addLast:
				(self
					at: aThreeArgumentBlockOrNumber rounded
					ifAbsent: [^ copy])]
		ifFalse: [| contextSize |
			contextSize := self size.
			1 to: contextSize do: [:i | | node result |
				node := self at: i.
				(result :=
					aThreeArgumentBlockOrNumber
						value: node
						value: i
						value: contextSize) isNumber
					ifTrue: [
						result rounded = i
							ifTrue: [copy addLast: node]]
					ifFalse: [
						result asXPathBoolean
							ifTrue: [copy addLast: node]]]].
	"filtering cannot change the sort order"
	^ copy sortOrderFrom: self.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 9/4/2016 01:37'!
filterWithAll: aFilterCollection
	| filteredNodeSet |

	filteredNodeSet := self.
	"to:do: for speed"
	1 to: aFilterCollection size do: [:i |
		filteredNodeSet isEmpty
			ifTrue: [^ filteredNodeSet].
		filteredNodeSet :=
			filteredNodeSet filterWith: (aFilterCollection at: i)].
	^ filteredNodeSet.! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrder
	^ self sortOrder firstInDocumentOrderFrom: self! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:47'!
followingAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		followingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:47'!
followingSiblingAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		followingSiblingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'testing' stamp: 'monty 1/16/2015 05:26'!
includes: aNode
	^ self set includes: aNode! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:35'!
intersection: aNodeSet
	^ (self select: [:each | aNodeSet includes: each]) sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:48'!
namespaceAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		namespaceAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:42'!
parentAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		parentAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:44'!
precedingAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		precedingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:45'!
precedingSiblingAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		precedingSiblingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/13/2015 22:15'!
reject: aBlock
	"reject doesn't change sort order"
	^ (super reject: aBlock) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 10/18/2015 08:39'!
reverseInPlace
	| previousSortOrder start end |

	"saved because swap:with: clears the sort order"
	previousSortOrder := self sortOrder.
	start := 1.
	end := self size.
	[start < end]
		whileTrue: [
			self swap: start with: end.
			start := start + 1.
			end := end - 1].
	self sortOrder: previousSortOrder asReversedSortOrder.! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 10/18/2015 04:17'!
reversed
	^ super reversed sortOrder: self sortOrder asReversedSortOrder! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/5/2015 17:52'!
select: aBlock
	"select doesn't change sort order"
	^ (super select: aBlock) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:47'!
selfAxis: aStringOrBlockOrNodeTestWithFilters
	^ self sortOrder
		on: self
		selfAxis: aStringOrBlockOrNodeTestWithFilters! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 4/15/2015 11:45'!
set
	"IdentitySet is not used because namespace nodes implement ="
	^ set ifNil: [set := Set new: self capacity]! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 1/26/2015 19:01'!
sort
	self sortOrder documentOrderSort: self! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 6/7/2015 00:44'!
sort: aSortBlock
	super sort: aSortBlock.
	self sortOrder: nil.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 10/6/2015 23:51'!
sortOrder
	sortOrder
		ifNil: [
			self size > 1
				ifTrue: [sortOrder := XPathUnknownSortOrder new]
				ifFalse: [
					"safe for node sets with <= 1 node"
					sortOrder := XPathDocumentSortOrder new]].
	^ sortOrder.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/26/2015 17:48'!
sortOrder: aSortOrder
	sortOrder := aSortOrder! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 4/14/2015 07:26'!
sortOrderFrom: aNodeSet
	sortOrder := aNodeSet sortOrder! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 8/16/2015 21:33'!
stringValue
	"returns XPath string-value for the first node in document order"
	^ self asXPathString! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 3/27/2015 01:16'!
stringValues
	"returns XPath string-values of nodes"
	^ self collect: [:each | each stringValue]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 01:17'!
stringValuesDo: aBlock
	"enumerates XPath string-values of nodes"
	self do: [:each | aBlock value: each stringValue]! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 6/7/2015 06:10'!
swap: aFirstIndex with: aSecondIndex
	super
		swap: aFirstIndex
		with: aSecondIndex.
	self sortOrder: nil.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:11'!
union: aNodeSet
	"XPath node set union operator"
	^ self copy
		addAll: aNodeSet;
		sort! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
| aNodeSet
	"redefined here for portability"
	^ self union: aNodeSet! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/21/2016 12:47'!
~ aStringOrBlockOrNodeTestWithFilters
	^ self selfAxis: aStringOrBlockOrNodeTestWithFilters! !

!Object class methodsFor: '*XPath-Core' stamp: 'monty 10/29/2015 05:07'!
xPathNewFrom: anObject
	"used to convert function arguments and return values"
	^ anObject! !

Object subclass: #XPath
	instanceVariableNames: 'xPathSource compiledXPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPath class
	instanceVariableNames: 'compiledXPathCache'!

!XPath commentStamp: 'monty 6/15/2015 06:39' prior: 0!
This class evaluates XPath expressions in the context of XMLNodes with optional custom context objects to control evaluation. It supports complete XPath 1.0 syntax with extensions.

Basic usage:
	| doc path result context |
	doc := XMLDOMParser parse: '<test>test</test>'.
	path := XPath for: '/test'.
	result := path in: doc.

	"with a custom context"
	path := XPath for: '/*[name() = $name]'.
	context :=  XPathContext new.
	context variableAt: 'name' put: 'test'.
	result := path in: doc context: context.

The syntax extensions are:
- Prefix wildcards in name tests like "*:name"
- Expanded name tests like "Q{namespaceURI}localName" that allow easier namespace testing 
- The element(), attribute(), and namespace() type tests that can also have embedded name tests like "element(name)"

Unlike standard XPath, by default prefixes in node tests are matched against literal prefixes of nodes, so you don't need to declare prefixes in the context before using them in node tests. Declaring at least one prefix triggers standard behavior. See XPathContext for more.

XPath expressions can be encoded directly in Smalltalk using special binary selectors on XMLNodes and  XMLNodeSets:
	xmlNode //  'entry' / '*' /'link' @ 'href'.!

XPath class
	instanceVariableNames: 'compiledXPathCache'!

!XPath class methodsFor: 'clearing' stamp: 'monty 10/30/2015 11:05'!
clearCompiledXPathCache
	"self clearCompiledXPathCache"
	compiledXPathCache
		ifNotNil: [compiledXPathCache clear]! !

!XPath class methodsFor: 'private' stamp: 'monty 10/9/2016 03:31'!
compiledXPathCache
	^ compiledXPathCache
		ifNil: [compiledXPathCache := XMLKeyValueCache maxSize: 512]! !

!XPath class methodsFor: 'accessing' stamp: 'monty 6/15/2015 06:12'!
compiledXPathCacheAt: anXPathSourceString
	^ self compiledXPathCache at: anXPathSourceString! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/17/2015 08:55'!
compiledXPathCacheAt: anXPathSourceString ifAbsent: aBlock
	^ self compiledXPathCache
		at: anXPathSourceString
		ifAbsent: aBlock! !

!XPath class methodsFor: 'accessing' stamp: 'monty 10/30/2015 10:57'!
compiledXPathCacheAt: anXPathSourceString ifAbsentPut: aBlock
	^ self compiledXPathCache
		at: anXPathSourceString
		ifAbsentPut: aBlock! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/17/2015 08:50'!
compiledXPathCacheAt: anXPathSourceString put: aCompiledXPath
	^ self compiledXPathCache
		at: anXPathSourceString
		put: aCompiledXPath! !

!XPath class methodsFor: 'instance creation' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString
	^ self new xPathSource: anXPathSourceString
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString in: aNode
	^ (self for: anXPathSourceString) in: aNode
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString in: aNode context: aContext
	^ (self for: anXPathSourceString)
		in: aNode
		context: aContext! !

!XPath class methodsFor: 'class initialization' stamp: 'monty 9/26/2016 13:32'!
initialize
	"self initialize"

	self clearCompiledXPathCache! !

XPath initialize!

!XPath class methodsFor: 'accessing' stamp: 'monty 1/15/2015 04:49'!
maxCachedCompiledXPaths
	^ self compiledXPathCache maxSize! !

!XPath class methodsFor: 'accessing' stamp: 'monty 1/15/2015 04:50'!
maxCachedCompiledXPaths: anInteger
	self compiledXPathCache maxSize: anInteger! !

!XPath methodsFor: 'converting' stamp: 'monty 1/17/2015 04:38'!
asXPath
	^ self! !

!XPath methodsFor: 'compiling' stamp: 'monty 3/2/2015 15:33'!
compile
	^ self compileWith: self compilerClass new! !

!XPath methodsFor: 'compiling' stamp: 'monty 3/2/2015 15:33'!
compileWith: anXPathCompiler
	compiledXPath := anXPathCompiler compile: self xPathSource.
	self class
		compiledXPathCacheAt: self xPathSource
		put: compiledXPath.
	^ compiledXPath.! !

!XPath methodsFor: 'accessing' stamp: 'monty 3/2/2015 15:33'!
compiledXPath
	^ compiledXPath ifNil: [
		compiledXPath :=
			self class
				compiledXPathCacheAt: self xPathSource
				ifAbsent: [self compile]]! !

!XPath methodsFor: 'accessing' stamp: 'monty 12/22/2014 03:12'!
compilerClass
	^ XPathCompiler! !

!XPath methodsFor: 'accessing' stamp: 'monty 1/19/2015 08:26'!
contextClass
	^ XPathContext! !

!XPath methodsFor: 'evaluating' stamp: 'monty 5/11/2015 20:59'!
evaluate
	"used to evaluate expressions that don't use a context node"
	^ self in: nil! !

!XPath methodsFor: 'evaluating' stamp: 'monty 6/1/2015 19:39'!
in: aNode
	"evaluate in context of aNode"
	^ self
		in: aNode
		context: self contextClass new! !

!XPath methodsFor: 'evaluating' stamp: 'monty 11/20/2015 20:22'!
in: aNode context: aContext
	"evaluate in context of aNode with aContext controlling evaluation"
	^ self compiledXPath
		value: aNode
		value: aContext! !

!XPath methodsFor: 'printing' stamp: 'monty 11/19/2015 22:31'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self xPathSource;
		nextPut: $).! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
xPathSource
	^ xPathSource! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
xPathSource: anXPathSourceString
	xPathSource := anXPathSourceString! !

Object subclass: #XPathAxis
	instanceVariableNames: 'axisSpecifier replacementSelector defaultNodeTestParserContextClass isImplicit isStartOfRelativeLocationPath isFirstAxis'
	classVariableNames: 'AxisSpecifiers'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathAxis commentStamp: 'monty 3/4/2016 15:18' prior: 0!
This class holds the current axis while a step is being parsed and maps them to selectors that implement the axis and parser context classes to parse the node test after.!

!XPathAxis class methodsFor: 'private' stamp: 'monty 4/10/2015 07:00'!
axisSpecifiers
	^ AxisSpecifiers! !

!XPathAxis class methodsFor: 'private' stamp: 'monty 12/31/2016 00:18'!
axisSpecifiersTemplate
	"Returns an array of arrays where each subarray has an axis name,
	a selector to map it to, and the principal node type for that axis,
	which is used to determine the parser context class when parsing
	the node test after."

	^ #(
		#('ancestor'           '%%'  element)
		#('ancestor-or-self'   '%%~' element)
		#('attribute'          '@'   attribute)
		#('child'              '/'   element)
		#('descendant'         '//'  element)
		#('descendant-or-self' '//~' element)
		#('following'          '>>'  element)
		#('following-sibling'  '>>>' element)
		#('namespace'          '@@'  namespace)
		#('parent'             '%'   element)
		#('preceding'          '<<'  element)
		#('preceding-sibling'  '<<<' element)
		#('self'               '~'   element)
	)! !

!XPathAxis class methodsFor: 'class initialization' stamp: 'monty 9/28/2016 22:31'!
initialize
	"self initialize"

	| temp |

	"use a temp to fully initialize it before assignment to avoid possible
	race conditions during class reinitialization"
	temp := Dictionary new.
	self axisSpecifiersTemplate do: [:each |
		| axisSpecifier replacementSelector principalNodeType parserContextClass |
		axisSpecifier := each first.
		replacementSelector := each second.
		principalNodeType := each third.
		parserContextClass :=
			principalNodeType = #attribute
				ifTrue: [XPathNodeTestParserAttributeContext]
				ifFalse: [
					principalNodeType = #namespace
						ifTrue: [XPathNodeTestParserNamespaceContext]
						ifFalse: [XPathNodeTestParserElementContext]].
		temp
			at: axisSpecifier
			put: replacementSelector -> parserContextClass].
	AxisSpecifiers := temp.! !

XPathAxis initialize!

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/13/2015 11:27'!
axisSpecifier
	^ axisSpecifier! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 4/16/2015 12:49'!
axisSpecifier: anAxisSpecifier
	anAxisSpecifier = axisSpecifier
		ifFalse: [
			axisSpecifier := anAxisSpecifier.
			replacementSelector := nil.
			defaultNodeTestParserContextClass := nil].
	"now explicit"
	isImplicit := false.! !

!XPathAxis methodsFor: 'changing' stamp: 'monty 11/18/2015 22:16'!
beDefaultImplicitAxis
	axisSpecifier := 'child'.
	replacementSelector := '/'.
	defaultNodeTestParserContextClass := XPathNodeTestParserElementContext.
	isImplicit := true.
	isFirstAxis := false.
	isStartOfRelativeLocationPath := false.! !

!XPathAxis methodsFor: 'changing' stamp: 'monty 4/16/2015 11:48'!
beFirstAxis
	isFirstAxis := true! !

!XPathAxis methodsFor: 'changing' stamp: 'monty 4/16/2015 12:46'!
beStartOfRelativeLocationPath
	isStartOfRelativeLocationPath := true! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 4/11/2015 04:10'!
defaultNodeTestParserContextClass
	^ defaultNodeTestParserContextClass
		ifNil: [
			self lookupAxisSpecifier.
			defaultNodeTestParserContextClass]! !

!XPathAxis methodsFor: 'private' stamp: 'monty 4/10/2015 07:36'!
errorUnrecognizedAxisSpecifier
	XPathSyntaxException
		formatSignal: 'Unrecognized axis specifier "{1}"'
		with: self axisSpecifier! !

!XPathAxis methodsFor: 'initialization' stamp: 'monty 11/18/2015 22:16'!
initialize
	super initialize.
	self beDefaultImplicitAxis.! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 4/16/2015 11:48'!
isFirstAxis
	^ isFirstAxis! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 4/16/2015 12:45'!
isImplicitAxis
	^ isImplicit! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 1/14/2015 02:34'!
isStartOfRelativeLocationPath
	^ isStartOfRelativeLocationPath! !

!XPathAxis methodsFor: 'private' stamp: 'monty 4/11/2015 10:00'!
lookupAxisSpecifier
	| association |

	association :=
		AxisSpecifiers
			at: self axisSpecifier
			ifAbsent: [self errorUnrecognizedAxisSpecifier].
	replacementSelector := association key.
	defaultNodeTestParserContextClass := association value.! !

!XPathAxis methodsFor: 'printing' stamp: 'monty 4/22/2015 16:29'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self axisSpecifier;
		nextPut: $).! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 4/11/2015 04:10'!
replacementSelector
	^ replacementSelector
		ifNil: [
			self lookupAxisSpecifier.
			replacementSelector]! !

Object subclass: #XPathComparable
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathComparable commentStamp: 'monty 2/23/2016 07:29' prior: 0!
An abstract class for wrapping XPath types to polymorphically implement XPath comparison operators.!

XPathComparable subclass: #XPathBooleanComparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathBooleanComparable commentStamp: 'monty 2/23/2016 07:29' prior: 0!
A class for wrapping XPath booleans to polymorphically implement XPath comparison operators.!

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
!!= aComparable
	^ aComparable notEqualsBoolean: value! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
< aComparable
	^ aComparable greaterThanBoolean: value! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
<= aComparable
	^ (aComparable greaterThanBoolean: value)
		or: [aComparable equalsBoolean: value]! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:02'!
= aComparable
	^ aComparable equalsBoolean: value! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
> aComparable
	^ aComparable lessThanBoolean: value! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
>= aComparable
	^ (aComparable lessThanBoolean: value)
		or: [aComparable equalsBoolean: value]! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:02'!
equalsBoolean: aBoolean
	^ value = aBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNodeSet: aNodeSet
	^ value = aNodeSet asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNumber: aNumber
	^ value = aNumber asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsString: aString
	^ value = aString asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	^ value asXPathNumber > aBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNodeSet: aNodeSet
	^ value asXPathNumber > aNodeSet asXPathBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	^ value asXPathNumber > aNumber asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	^ value asXPathNumber > aString asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	^ value asXPathNumber < aBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNodeSet: aNodeSet
	^ value asXPathNumber < aNodeSet asXPathBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	^ value asXPathNumber < aNumber asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	^ value asXPathNumber < aString asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsBoolean: aBoolean
	^ value ~= aBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsNodeSet: aNodeSet
	^ value ~= aNodeSet asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsNumber: aNumber
	^ value ~= aNumber asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsString: aString
	^ value ~= aString asXPathBoolean! !

!XPathComparable class methodsFor: 'instance creation' stamp: 'monty 2/23/2016 13:07'!
value: aValue
	^ self new setValue: aValue! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
!!= aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
< aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
<= aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
= aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
> aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
>= aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:02'!
equalsBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'printing' stamp: 'monty 3/5/2016 14:05'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: value;
		nextPut: $).! !

!XPathComparable methodsFor: 'initialization' stamp: 'monty 2/23/2016 13:07'!
setValue: anObject
	value := anObject! !

XPathComparable subclass: #XPathNodeSetComparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNodeSetComparable commentStamp: 'monty 2/23/2016 07:30' prior: 0!
A class for wrapping XPath node sets to polymorphically implement XPath comparison operators.!

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
!!= aComparable
	^ aComparable notEqualsNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
< aComparable
	^ aComparable greaterThanNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
<= aComparable
	^ (aComparable greaterThanNodeSet: value)
		or: [aComparable equalsNodeSet: value]! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
= aComparable
	^ aComparable equalsNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
> aComparable
	^ aComparable lessThanNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
>= aComparable
	^ (aComparable lessThanNodeSet: value)
		or: [aComparable equalsNodeSet: value]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:02'!
equalsBoolean: aBoolean
	^ value asXPathBoolean = aBoolean! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNodeSet: aNodeSet
	| stringValues |

	stringValues := Set new: value size.
	value do: [:each | stringValues add: each stringValue].
	^ aNodeSet anySatisfy: [:node | stringValues includes: node stringValue].! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNumber: aNumber
	^ value anySatisfy: [:each | each stringValue asXPathNumber = aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsString: aString
	^ value anySatisfy: [:each | each stringValue = aString]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	^ value asXPathBoolean asXPathNumber > aBoolean asXPathNumber! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNodeSet: aNodeSet
	| least |

	aNodeSet do: [:each | | number |
		number := each stringValue asXPathNumber.
		(least isNil
			or: [number < least])
			ifTrue: [least := number]].
	^ least notNil
		and: [value anySatisfy: [:each | each stringValue asXPathNumber > least]].! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	^ value anySatisfy: [:each | each stringValue asXPathNumber > aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	| number |

	number := aString asXPathNumber.
	^ value anySatisfy: [:each | each stringValue asXPathNumber > number]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	^ value asXPathBoolean asXPathNumber < aBoolean asXPathNumber! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNodeSet: aNodeSet
	| greatest |

	aNodeSet do: [:each | | number |
		number := each stringValue asXPathNumber.
		(greatest isNil
			or: [number > greatest])
			ifTrue: [greatest := number]].
	^ greatest notNil
		and: [value anySatisfy: [:each | each stringValue asXPathNumber < greatest]].! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	^ value anySatisfy: [:each | each stringValue asXPathNumber < aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	| number |

	number := aString asXPathNumber.
	^ value anySatisfy: [:each | each asXPathNumber < number]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsBoolean: aBoolean
	^ value asXPathBoolean ~= aBoolean! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/23/2016 12:59'!
notEqualsNodeSet: aNodeSet
	| stringValues |

	"should return true according to spec when aNodeSet and value each have at
	least one node that don't have the same string-values"
	stringValues := value collect: [:each | each stringValue].
	aNodeSet do: [:node | | stringValue |
		stringValue := node stringValue.
		stringValues do: [:each |
			each = stringValue
				ifFalse: [^ true]]].
	^ false.! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsNumber: aNumber
	^ value anySatisfy: [:each | each stringValue asXPathNumber ~= aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsString: aString
	^ value anySatisfy: [:each | each stringValue ~= aString]! !

XPathComparable subclass: #XPathNumberComparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNumberComparable commentStamp: 'monty 2/23/2016 07:30' prior: 0!
A class for wrapping XPath numbers to polymorphically implement XPath comparison operators.!

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
!!= aComparable
	^ aComparable notEqualsNumber: value! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
< aComparable
	^ aComparable greaterThanNumber: value! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
<= aComparable
	^ (aComparable greaterThanNumber: value)
		or: [aComparable equalsNumber: value]! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
= aComparable
	^ aComparable equalsNumber: value! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
> aComparable
	^ aComparable lessThanNumber: value! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
>= aComparable
	^ (aComparable lessThanNumber: value)
		or: [aComparable equalsNumber: value]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:02'!
equalsBoolean: aBoolean
	^ value asXPathBoolean = aBoolean! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | value = each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNumber: aNumber
	^ value = aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsString: aString
	^ value = aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	^ value > aBoolean asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | value > each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	^ value > aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	^ value > aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	^ value < aBoolean asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | value < each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	^ value < aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	^ value < aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsBoolean: aBoolean
	^ value asXPathBoolean ~= aBoolean! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | value ~= each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsNumber: aNumber
	^ value ~= aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsString: aString
	^ value ~= aString asXPathNumber! !

XPathComparable subclass: #XPathStringComparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathStringComparable commentStamp: 'monty 2/23/2016 07:30' prior: 0!
A class for wrapping XPath strings to polymorphically implement XPath comparison operators.!

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
!!= aComparable
	^ aComparable notEqualsString: value! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
< aComparable
	^ aComparable greaterThanString: value! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
<= aComparable
	^ (aComparable greaterThanString: value)
		or: [aComparable equalsString: value]! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
= aComparable
	^ aComparable equalsString: value! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
> aComparable
	^ aComparable lessThanString: value! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
>= aComparable
	^ (aComparable lessThanString: value)
		or: [aComparable equalsString: value]! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:02'!
equalsBoolean: aBoolean
	^ value asXPathBoolean = aBoolean! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | value = each stringValue]! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsNumber: aNumber
	^ value asXPathNumber = aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
equalsString: aString
	^ value = aString! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	^ value asXPathNumber > aBoolean asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNodeSet: aNodeSet
	| number |
	
	number := value asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number > each stringValue asXPathNumber].! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	^ value asXPathNumber > aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	^ value asXPathNumber > aString asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	^ value asXPathNumber < aBoolean asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNodeSet: aNodeSet
	| number |
	
	number := value asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number < each stringValue asXPathNumber].! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	^ value asXPathNumber < aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	^ value asXPathNumber < aString asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsBoolean: aBoolean
	^ value asXPathBoolean ~= aBoolean! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | value ~= each stringValue]! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
notEqualsNumber: aNumber
	^ value asXPathNumber ~= aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
notEqualsString: aString
	^ value ~= aString! !

Object subclass: #XPathCompiler
	instanceVariableNames: ''
	classVariableNames: 'SystemCompilerClass'
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathCompiler commentStamp: 'monty 1/18/2015 06:22' prior: 0!
This class compiles XPath expressions by first translating them into Smalltalk using an XPathExpressionParser and handler and then compiling the result with the system compiler.!

!XPathCompiler class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:35'!
systemCompilerClass
	^ SystemCompilerClass
		ifNil: [
			"On Pharo/Squeak, Behavior class>>#compilerClass returns the  platform's
			preferred compiler class that can be sent #evaluate: to compile a
			string. On GS, any object can be sent #evaluate: to compile a string."
			SystemCompilerClass :=
				(Behavior respondsTo: #compilerClass)
					ifTrue: [Behavior compilerClass]
					ifFalse: [Behavior]]! !

!XPathCompiler class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:35'!
systemCompilerClass: aClass
	SystemCompilerClass := aClass! !

!XPathCompiler methodsFor: 'compiling' stamp: 'monty 1/12/2015 05:01'!
compile: aStringOrStream
	^ self compileWithParser:
		(self parserClass
			on: aStringOrStream
			for: self parserHandlerClass new)! !

!XPathCompiler methodsFor: 'private' stamp: 'monty 9/25/2016 23:30'!
compileGeneratedSourceCode: aString
	^ self class systemCompilerClass evaluate: aString! !

!XPathCompiler methodsFor: 'compiling' stamp: 'monty 2/21/2016 13:08'!
compileWithParser: aParser
	^ self compileGeneratedSourceCode: aParser parse! !

!XPathCompiler methodsFor: 'accessing' stamp: 'monty 1/8/2015 05:56'!
parserClass
	^ XPathExpressionParser! !

!XPathCompiler methodsFor: 'accessing' stamp: 'monty 2/21/2016 01:36'!
parserHandlerClass
	^ XPathCompilingExpressionParserHandler! !

Object subclass: #XPathContext
	instanceVariableNames: 'variables namespaceScope functions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext commentStamp: 'monty 11/19/2015 22:09' prior: 0!
An XPathContext controls evaluation of XPath expressions. Contexts have a function library, variable bindings, and namespace mappings.

By default, qualified name tests like 'prefix:name' and wildcard tests like 'prefix:*' will match against the prefix directly. This isn't like the standard, where prefixes in node tests must be declared in the context before evaluation and the namespace they're bound to is matched against the (non-default) namespace of the node, but it's easier to use.

To get standard behavior, just declare at least one prefix in the context before evaluation (then every prefix must be declared in the context and the namespace URIs are matched instead of the literal prefixes).!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:30'!
defaultFunctions
	^ defaultFunctions
		ifNil: [defaultFunctions := XPathFunctionSet default]! !

!XPathContext class methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:00'!
defaultFunctions: aFunctionSetOrNil
	"can be used to specify a custom default function set"

	defaultFunctions := aFunctionSetOrNil! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:49'!
functions: aFunctionSet
	^ self new functions: aFunctionSet! !

!XPathContext class methodsFor: 'class initialization' stamp: 'monty 3/8/2015 11:45'!
initialize
	"self initialize"

	self defaultFunctions: nil! !

XPathContext initialize!

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
namespaces: anAssociationCollection
	^ self new declareNamespaces: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
variables: anAssociationCollection
	^ self new variables: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection functions: aFunctionSet
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection;
		functions: aFunctionSet! !

!XPathContext methodsFor: 'adding' stamp: 'monty 3/2/2016 14:19'!
addFunction: aFunction
	"use copy-on-write so the default function set isn't modified"
	^ self copiedFunctions add: aFunction! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/6/2016 14:26'!
copiedFunctions
	"used to implement copy-on-write for functions"
	^ functions := self functions copy! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 1/19/2015 08:24'!
declareNamespaces: anAssociationCollection
	self namespaceScope mapPrefixesAndURIs: anAssociationCollection! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/21/2015 23:11'!
declarePrefix: aPrefix uri: aURI
	self namespaceScope
		mapPrefix: aPrefix
		to: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:01'!
errorUndeclaredFunction: aFunctionName
	XPathUndeclaredFunctionException
		formatSignal: 'Undeclared function {1}()'
		with: aFunctionName! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/5/2015 07:05'!
errorUndeclaredPrefix: aPrefix
	XPathUndeclaredPrefixException
		formatSignal: 'Prefix "{1}" was not declared in the XPath context'
		with: aPrefix! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:02'!
errorUndeclaredVariable: aVariableName
	XPathUndeclaredVariableException
		formatSignal: 'Undeclared variable reference ${1}'
		with: aVariableName! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 3/2/2016 14:17'!
functionNamed: aFunctionName
	^ self functions functionNamed: aFunctionName! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 3/2/2016 14:17'!
functionNamed: aFunctionName ifAbsent: aBlock
	^ self functions 
		functionNamed: aFunctionName
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/2/2016 14:22'!
functions
	"the default function set won't be directly modified because the add/remove
	methods use copy-on-write semantics"
	^ functions ifNil: [functions := self class defaultFunctions]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 3/6/2016 14:42'!
functions: aFunctionSet
	"will only be modified by copy-on-write"
	functions := aFunctionSet asXPathFunctionSet! !

!XPathContext methodsFor: 'testing' stamp: 'monty 3/6/2016 13:19'!
hasFunctions
	^ self functions notEmpty! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 01:02'!
hasNamespaces
	^ namespaceScope notNil
		and: [namespaceScope hasNamespaces]! !

!XPathContext methodsFor: 'testing' stamp: 'monty 3/6/2016 11:28'!
hasVariables
	^ self variables notEmpty! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/10/2015 22:05'!
includesFunction: aFunction
	^ self functions includes: aFunction! !

!XPathContext methodsFor: 'testing' stamp: 'monty 1/17/2015 04:48'!
includesVariable: aVariableName
	^ self variables includesKey: aVariableName! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 20:52'!
isDeclaredPrefix: aPrefix
	^ self namespaceScope includesPrefix: aPrefix! !

!XPathContext methodsFor: 'testing' stamp: 'monty 3/21/2015 23:11'!
isDeclaredPrefix: aPrefix uri: aURI
	^ self namespaceScope
		includesPrefix: aPrefix
		mappedTo: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 12/30/2014 03:46'!
namespaceScope
	^ namespaceScope ifNil: [namespaceScope := XMLNamespaceScope new]! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/2/2016 14:19'!
removeFunction: aFunction
	"use copy-on-write so the default function set isn't modified"
	^ self copiedFunctions remove: aFunction! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/2/2016 14:19'!
removeFunction: aFunction ifAbsent: aBlock
	"use copy-on-write so the default function set isn't modified"
	^ self copiedFunctions
		remove: aFunction
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/6/2016 13:33'!
removeFunctions
	self copiedFunctions removeAll! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/2/2016 14:14'!
removeVariable: aVariable
	^ self variables removeKey: aVariable! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/2/2016 14:14'!
removeVariable: aVariable ifAbsent: aBlock
	^ self variables
		removeKey: aVariable
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/6/2016 11:29'!
removeVariables
	self variables removeAll! !

!XPathContext methodsFor: 'private' stamp: 'monty 10/5/2016 17:56'!
resolveFunctionReference: aFunctionName contextNode: aContextNode arguments: anArgumentArray
	^ (self
		functionNamed: aFunctionName
		ifAbsent: [self errorUndeclaredFunction: aFunctionName])
			context: self
			contextNode: aContextNode
			arguments: anArgumentArray! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 2/26/2016 04:51'!
resolvePrefix: aPrefix
	^ self namespaceScope resolvePrefix: aPrefix! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 2/26/2016 04:36'!
resolvePrefix: aPrefix ifUnresolvable: aBlock
	^ self namespaceScope
		resolvePrefix: aPrefix
		ifUnresolvable: aBlock! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/26/2016 04:49'!
resolvePrefixReference: aPrefix
	^ self
		resolvePrefix: aPrefix
		ifUnresolvable: [self errorUndeclaredPrefix: aPrefix]! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 2/24/2016 04:12'!
resolvePrefixesOfNamespaceURI: aURI
	^ self namespaceScope resolvePrefixesOfNamespaceURI: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/26/2016 04:50'!
resolveVariableReference: aVariableName
	^ self
		variableAt: aVariableName
		ifAbsent: [self errorUndeclaredVariable: aVariableName]! !

!XPathContext methodsFor: 'private' stamp: 'monty 11/8/2016 19:32'!
testForAttributeWithPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefixReference: aPrefix.
			^ [:node |
				node isAttribute
					and: [node namespaceURI = namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isAttribute
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 11/8/2016 19:32'!
testForAttributeWithPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefixReference: aPrefix.
			^ [:node |
				node isAttribute
					and: [node localName = aLocalName
						and: [node namespaceURI = namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithXMLPrefix: aPrefix.
			^ [:node |
				node isAttribute
					and: [node name = name]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 11/8/2016 19:33'!
testForElementWithPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefixReference: aPrefix.
			^ [:node |
				node isElement
					and: [node namespaceURI = namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isElement
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 11/8/2016 19:33'!
testForElementWithPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefixReference: aPrefix.
			^ [:node |
				node isElement
					and: [node localName = aLocalName
						and: [node namespaceURI = namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithXMLPrefix: aPrefix.
			^ [:node |
				node isElement
					and: [node name = name]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 11/8/2016 19:33'!
testForNamespaceWithPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefixReference: aPrefix.
			^ [:node |
				node isNamespace
					and: [node namespaceURI = namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isNamespace
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 11/8/2016 19:33'!
testForNamespaceWithPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefixReference: aPrefix.
			^ [:node |
				node isNamespace
					and: [node localName = aLocalName
						and: [node namespaceURI = namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithXMLPrefix: aPrefix.
			^ [:node |
				node isNamespace
					and: [node name = name]]]! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/2/2016 14:10'!
undeclarePrefix: aPrefix
	self namespaceScope
		unmapPrefix: aPrefix
		ifAbsent: [nil]! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/2/2016 16:27'!
undeclarePrefixes
	self namespaceScope unmapPrefixes! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 3/6/2016 11:23'!
variableAt: aVariableName
	^ self variables
		at: aVariableName
		ifAbsent: [nil]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsent: aBlock
	^ self variables
		at: aVariableName
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsentPut: aBlock
	^ self variables
		at: aVariableName
		ifAbsentPut: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:48'!
variableAt: aVariableName put: aValue
	^ self variables
		at: aVariableName
		put: aValue! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/17/2015 04:49'!
variables
	^ variables ifNil: [variables := Dictionary new]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 2/23/2016 09:50'!
variables: anAssociationCollection
	variables := Dictionary new: anAssociationCollection size.
	anAssociationCollection associationsDo: [:each |
		variables
			at: each key
			put: each value].! !

Object subclass: #XPathFunction
	instanceVariableNames: 'context contextNode arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

XPathFunction class
	instanceVariableNames: 'functionPrototype'!

!XPathFunction commentStamp: 'monty 10/7/2016 04:17' prior: 0!
An abstract class for XPath functions. Subclasses need to implement the class #functionPrototype method to return a string with an XPath function prototype and then implement the instance-side #function method to implement the function and return its value.

When invoked, the arguments and the return value are automatically converted to the types specified by the prototype.!

XPathFunction class
	instanceVariableNames: 'functionPrototype'!

XPathFunction subclass: #XPathBooleanFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathBooleanFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath boolean conversion function.!

!XPathBooleanFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'boolean boolean(object)'! !

!XPathBooleanFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:13'!
function
	^ self firstArgument! !

XPathFunction subclass: #XPathCeilingFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCeilingFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath ceiling function.!

!XPathCeilingFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'number ceiling(number)'! !

!XPathCeilingFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:13'!
function
	^ self firstArgument ceiling! !

XPathFunction subclass: #XPathConcatFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathConcatFunction commentStamp: 'monty 3/13/2015 21:27' prior: 0!
XPath string concatenation function. Concatenates two or more strings.!

!XPathConcatFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string concat(string, string, string*)'! !

!XPathConcatFunction methodsFor: 'invoking' stamp: 'monty 10/9/2016 19:02'!
function
	| writeStream |

	writeStream := (String new: self totalArguments * 10) writeStream.
	1 to: self totalArguments do: [:i |
		writeStream nextPutAll: (self argumentAt: i)].
	^ writeStream contents.! !

XPathFunction subclass: #XPathContainsFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathContainsFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath contains substring function.!

!XPathContainsFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'boolean contains(string, string)'! !

!XPathContainsFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:18'!
function
	"use findString:startingAt: for portability"
	^ (self firstArgument
		findString: self lastArgument
		startingAt: 1) > 0! !

XPathFunction subclass: #XPathCountFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCountFunction commentStamp: 'monty 6/15/2015 00:40' prior: 0!
XPath node set count (size) function.!

!XPathCountFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'number count(node-set)'! !

!XPathCountFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:18'!
function
	^ self firstArgument size! !

XPathFunction subclass: #XPathEndsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathEndsWithFunction commentStamp: 'monty 6/15/2015 00:40' prior: 0!
Non-standard; added for completeness with starts-with().!

!XPathEndsWithFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'boolean ends-with(string, string)'! !

!XPathEndsWithFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:18'!
function
	^ self firstArgument endsWith: self lastArgument! !

XPathFunction subclass: #XPathFalseFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFalseFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath false function.!

!XPathFalseFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'boolean false()'! !

!XPathFalseFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:51'!
function
	^ false! !

XPathFunction subclass: #XPathFloorFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFloorFunction commentStamp: 'monty 12/22/2014 21:18' prior: 0!
XPath floor function.!

!XPathFloorFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'number floor(number)'! !

!XPathFloorFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:19'!
function
	^ self firstArgument floor! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 3/6/2016 14:39'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asXPathFunctionSetWithFunction: self! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 3/6/2016 14:39'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asXPathFunctionSetSubtractedFromFunction: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 9/22/2016 17:06'!
asXPathFunctionSet
	^ self functionSetClass with: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asXPathFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetWithFunction: aFunction
	^ self asXPathFunctionSet
		add: aFunction;
		yourself! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 3/6/2016 14:40'!
asXPathFunctionSetWithFunctions: aFunctionSet
	^ self asXPathFunctionSet
		addAll: aFunctionSet;
		yourself! !

!XPathFunction class methodsFor: 'instance creation' stamp: 'monty 10/6/2016 21:40'!
context: aContext contextNode: aContextNode arguments: aSequenceableCollection
	^ self new
		setContext: aContext
		contextNode: aContextNode
		arguments: aSequenceableCollection! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 9/27/2016 13:33'!
functionName
	^ self functionPrototype functionName! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:30'!
functionPrototype
	^ functionPrototype
		ifNil: [
			functionPrototype :=
				(XPathFunctionPrototypeParser
					on: self functionPrototypeSource
					for: XPathTypedFunctionPrototypeParserHandler new)
					parse]! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:29'!
functionPrototype: aFunctionPrototype
	"
	self allSubclassesDo: [:each |
		each
			functionPrototype: nil;
			functionPrototype]
	"

	functionPrototype := aFunctionPrototype! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:29'!
functionPrototypeSource
	"Should return a protype string. See subclasses for examples."

	self subclassResponsibility! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 9/22/2016 17:06'!
functionSetClass
	^ XPathFunctionSet! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 10/7/2016 00:21'!
acceptsArguments
	^ self functionPrototype acceptsArguments! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 10/7/2016 00:21'!
acceptsOptionalArguments
	^ self functionPrototype acceptsOptionalArguments! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 10/7/2016 00:21'!
acceptsVariableArguments
	^ self functionPrototype acceptsVariableArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:20'!
argumentAt: anIndex
	^ self
		argumentAt: anIndex
		ifAbsent: [nil]! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:07'!
argumentAt: anIndex ifAbsent: aBlock
	^ self arguments
		at: anIndex
		ifAbsent: aBlock! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/7/2016 00:24'!
argumentTypeAt: anIndex
	^ self functionPrototype argumentTypeAt: anIndex! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:09'!
argumentTypeAt: anIndex ifAbsent: aBlock
	^ self functionPrototype
		argumentTypeAt: anIndex
		ifAbsent: aBlock! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:38'!
argumentTypes
	^ self functionPrototype argumentTypes! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/5/2016 18:01'!
arguments
	^ arguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/24/2014 23:45'!
context
	^ context! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/14/2015 04:58'!
contextNode
	^ contextNode! !

!XPathFunction methodsFor: 'private' stamp: 'monty 10/7/2016 04:14'!
errorAcceptsAtMost: anArgumentMaximum argumentsButGot: anArgumentTotal
	XPathArgumentNumberException
		formatSignal: '{1}() accepts at most {2} argument(s) but was called with {3}'
		with: self functionName
		with: anArgumentMaximum
		with: anArgumentTotal! !

!XPathFunction methodsFor: 'private' stamp: 'monty 10/7/2016 04:15'!
errorRequiresAtLeast: anArgumentMinimum argumentsButGot: anArgumentTotal
	XPathArgumentNumberException
		formatSignal:
			'{1}() requires at least {2} argument(s) but was called with {3}'
		with: self functionName
		with: anArgumentMinimum
		with: anArgumentTotal! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/7/2016 00:12'!
firstArgument
	^ self argumentAt: 1! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	self subclassResponsibility! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:38'!
functionName
	^ self functionPrototype functionName! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:28'!
functionPrototype
	^ self class functionPrototype! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 10/9/2016 19:21'!
hasArguments
	^ self totalArguments > 0! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:05'!
invoke
	^ self returnType xPathNewFrom: self function! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/7/2016 00:13'!
lastArgument
	^ self argumentAt: self totalArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:38'!
maxArguments
	^ self functionPrototype maxArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:38'!
minArguments
	^ self functionPrototype minArguments! !

!XPathFunction methodsFor: 'instance creation' stamp: 'monty 9/22/2016 17:30'!
newNodeSet
	^ self nodeSetClass new! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 9/27/2016 13:34'!
nodeSetClass
	^ XPathNodeSet! !

!XPathFunction methodsFor: 'printing' stamp: 'monty 9/23/2016 13:49'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self functionPrototype printOn: aStream.
	aStream nextPut: $).! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:38'!
returnType
	^ self functionPrototype returnType! !

!XPathFunction methodsFor: 'initialization' stamp: 'monty 10/9/2016 19:36'!
setArguments: aSequenceableCollection
	"ensure there aren't too many or too few"
	aSequenceableCollection size < self minArguments
		ifTrue: [
			self
				errorRequiresAtLeast: self minArguments
				argumentsButGot: aSequenceableCollection size].
	(self maxArguments notNil
		and: [aSequenceableCollection size > self maxArguments])
		ifTrue: [
			self
				errorAcceptsAtMost: self maxArguments
				argumentsButGot: aSequenceableCollection size].

	"convert them to the appropriate type (use to:do: for speed)"
	1 to: aSequenceableCollection size do: [:i |
		aSequenceableCollection
			at: i
			put:
				((self argumentTypeAt: i) xPathNewFrom:
					(aSequenceableCollection at: i))].

	arguments := aSequenceableCollection asArray.! !

!XPathFunction methodsFor: 'initialization' stamp: 'monty 10/9/2016 18:58'!
setContext: aContext contextNode: aContextNode arguments: aSequenceableCollection
	context := aContext.
	contextNode := aContextNode.
	self setArguments: aSequenceableCollection.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/7/2016 00:05'!
totalArguments
	^ self arguments size! !

XPathFunction subclass: #XPathIDFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathIDFunction commentStamp: 'monty 3/9/2015 21:50' prior: 0!
XPath id() function to select elements from the document of the context node by ID.!

!XPathIDFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'node-set id(object)'! !

!XPathIDFunction methodsFor: 'invoking' stamp: 'monty 11/23/2016 19:56'!
function
	| object ids document nodeSet |

	object := self firstArgument.
	ids := Set new.
	object class == self nodeSetClass
		ifTrue: [
			object do: [:each |
				self
					splitSpaceSeparatedIDs: each stringValue
					into: ids]]
		ifFalse: [
			self
				splitSpaceSeparatedIDs: object asXPathString
				into: ids].

	nodeSet := self newNodeSet.
	(ids notEmpty
		and: [self contextNode notNil
			and: [(document := self contextNode document) notNil]])
		ifTrue: [| element |
			ids do: [:each |
				((element := document findElementWithID: each) notNil
					and: [(nodeSet includes: element) not])
					ifTrue: [nodeSet addLast: element]]].
	^ nodeSet.! !

!XPathIDFunction methodsFor: 'private' stamp: 'monty 3/12/2016 19:09'!
splitSpaceSeparatedIDs: anIDString into: anIDSet
	| startIndex|

	1 to: anIDString size do: [:i | | nextChar |
		(nextChar := anIDString at: i) isXMLSeparator
			ifTrue: [
				startIndex
					ifNotNil: [
						anIDSet add: (anIDString copyFrom: startIndex to: i - 1).
						startIndex := nil]]
			ifFalse: [
				startIndex
					ifNil: [startIndex := i]]].
	startIndex
		ifNotNil: [
			anIDSet add:
				(anIDString copyFrom: startIndex to: anIDString size)].! !

XPathFunction subclass: #XPathLangFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLangFunction commentStamp: 'monty 3/25/2015 04:12' prior: 0!
XPath lang() function to test if the context node is in the scope of an xml:lang attribute value matching the argument.!

!XPathLangFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'boolean lang(string)'! !

!XPathLangFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:19'!
function
	^ self contextNode isInLanguage: self firstArgument! !

XPathFunction subclass: #XPathLocalNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLocalNameFunction commentStamp: 'monty 12/27/2014 00:36' prior: 0!
XPath local name function.!

!XPathLocalNameFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string local-name(node-set?)'! !

!XPathLocalNameFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:20'!
function
	| node |

	self hasArguments
		ifTrue: [node := self firstArgument firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil
		and: [node hasExpandedName])
		ifTrue: [^ node localName]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNameFunction commentStamp: 'monty 3/5/2015 15:46' prior: 0!
XPath name function. Returns expanded name or local name of a node or empty string if node has no name. Operates on argument node or the context node if called with no arguments.!

!XPathNameFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string name(node-set?)'! !

!XPathNameFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:12'!
function
	| node |

	self hasArguments
		ifTrue: [node := self firstArgument firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil
		and: [node hasExpandedName])
		ifTrue: [| namespaceURI |
			(self context hasNamespaces
				and: [(namespaceURI := node namespaceURI) notEmpty
					and: [node hasPrefix]])
				ifTrue: [
					((self context resolvePrefixesOfNamespaceURI: namespaceURI)
						ifEmpty: [^ node localName]
						ifNotEmpty: [:prefixes |
							^ node localName qualifyWithXMLPrefix: prefixes anyOne])]
				ifFalse: [^ node name]]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathNamespaceURIFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNamespaceURIFunction commentStamp: 'monty 12/27/2014 00:27' prior: 0!
XPath namespace URI function.!

!XPathNamespaceURIFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string namespace-uri(node-set?)'! !

!XPathNamespaceURIFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:12'!
function
	| node |

	self hasArguments
		ifTrue: [node := self firstArgument firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil
		and: [node hasExpandedName])
		ifTrue: [^ node namespaceURI]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNormalizeSpaceFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNormalizeSpaceFunction commentStamp: 'monty 6/15/2015 00:41' prior: 0!
XPath whitespace normalization function to remove leading and trailing whitespace and turn whitespace sequences into single spaces.!

!XPathNormalizeSpaceFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string normalize-space(string?)'! !

!XPathNormalizeSpaceFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:12'!
function
	| string writeStream isInWhitespace normalizedSpace |

	self hasArguments
		ifTrue: [string := self firstArgument]
		ifFalse: [string := self contextNode].

	"must use #writeStream instead of 'WriteStream on:' to get a 0-based
	stream on Gemstone"
	writeStream := (String new: string size) writeStream.
	isInWhitespace := false.
	normalizedSpace := Character space.
	string do: [:each |
		each isXMLSeparator
			ifTrue: [
				isInWhitespace
					ifFalse: [isInWhitespace := true]]
			ifFalse: [
				isInWhitespace
					ifTrue: [
						writeStream position > 0
							ifTrue: [writeStream nextPut: normalizedSpace].
						isInWhitespace := false].
				writeStream nextPut: each]].
	^ writeStream contents.! !

XPathFunction subclass: #XPathNotFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNotFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath negation function.!

!XPathNotFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'boolean not(boolean)'! !

!XPathNotFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 19:06'!
function
	^ self firstArgument not! !

XPathFunction subclass: #XPathNumberFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNumberFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number conversion function.!

!XPathNumberFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'number number(object?)'! !

!XPathNumberFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:12'!
function
	self hasArguments
		ifTrue: [^ self firstArgument]
		ifFalse: [^ self nodeSetClass with: self contextNode]! !

XPathFunction subclass: #XPathRoundFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathRoundFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number rounding function.!

!XPathRoundFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'number round(number)'! !

!XPathRoundFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 19:06'!
function
	^ self firstArgument rounded! !

XPathFunction subclass: #XPathStartsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStartsWithFunction commentStamp: 'monty 2/10/2015 02:59' prior: 0!
XPath string prefix testing function.!

!XPathStartsWithFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'boolean starts-with(string, string)'! !

!XPathStartsWithFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 19:05'!
function
	^ self firstArgument beginsWith: self lastArgument! !

XPathFunction subclass: #XPathStringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringFunction commentStamp: 'monty 12/22/2014 20:01' prior: 0!
XPath string conversion function.!

!XPathStringFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string string(object?)'! !

!XPathStringFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 19:05'!
function
	^ self firstArgument! !

XPathFunction subclass: #XPathStringLengthFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringLengthFunction commentStamp: 'monty 12/22/2014 21:24' prior: 0!
XPath string length function.
!

!XPathStringLengthFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'number string-length(string?)'! !

!XPathStringLengthFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:12'!
function
	self hasArguments
		ifTrue: [^ self firstArgument size]
		ifFalse: [^ self contextNode stringValue size]! !

XPathFunction subclass: #XPathSubstringAfterFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringAfterFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath function to return the substring after another substring.!

!XPathSubstringAfterFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string substring-after(string, string)'! !

!XPathSubstringAfterFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 19:05'!
function
	| string substring indexOfSubstring |

	string := self firstArgument.
	substring := self lastArgument.
	(indexOfSubstring :=
		string
			findString: substring
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: indexOfSubstring + substring size
				to: string size]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringBeforeFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringBeforeFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath function to return the substring before another substring.!

!XPathSubstringBeforeFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string substring-before(string, string)'! !

!XPathSubstringBeforeFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 19:04'!
function
	| string indexOfSubstring |

	string := self firstArgument.
	(indexOfSubstring :=
		string
			findString: self lastArgument
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: 1
				to:indexOfSubstring - 1]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath substring function. First argument is the source string, second is the one-based position, and third is the substring length.!

!XPathSubstringFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string substring(string, number, number?)'! !

!XPathSubstringFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 19:08'!
function
	| string start length |

	string := self argumentAt: 1.
	start := (self argumentAt: 2) rounded.
	self totalArguments > 2
		ifTrue: [length := (self argumentAt: 3) rounded]
		ifFalse: [length := string size - start + 1].

	(length > 0
		and: [start <= string size])
		ifTrue: [
			^ string
				copyFrom: (start max: 1)
				to: ((start max: 1) + length - 1 min: string size)]
		ifFalse: [^ '']	.! !

XPathFunction subclass: #XPathSumFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSumFunction commentStamp: 'monty 6/15/2015 00:44' prior: 0!
XPath node set sum function.!

!XPathSumFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'number sum(node-set)'! !

!XPathSumFunction methodsFor: 'invoking' stamp: 'monty 10/5/2016 18:25'!
function
	^ self firstArgument
		inject: 0
		into: [:i :each | i + each stringValue asXPathNumber]! !

XPathFunction subclass: #XPathTranslateFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTranslateFunction commentStamp: 'monty 6/15/2015 00:44' prior: 0!
XPath function to replace/delete all occurances of certain characters in a string.!

!XPathTranslateFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'string translate(string, string, string)'! !

!XPathTranslateFunction methodsFor: 'invoking' stamp: 'monty 10/9/2016 19:44'!
function
	| sourceString searchString replacementString replacementMap writeStream |

	sourceString := self argumentAt: 1.
	searchString := self argumentAt: 2.
	replacementString := self argumentAt: 3.
	replacementMap := Dictionary new.
	1 to: searchString size do: [:i |
		replacementMap
			at: (searchString at: i)
			ifAbsentPut: [
				replacementString
					at: i
					ifAbsent: [nil]]].

	writeStream := (String new: sourceString size) writeStream.
	sourceString do: [:each |	
		(replacementMap
			at: each
			ifAbsent: [each])
				ifNotNil: [:nextChar |
					writeStream nextPut: nextChar]].
	^ writeStream contents.! !

XPathFunction subclass: #XPathTrueFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTrueFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath true function.!

!XPathTrueFunction class methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:09'!
functionPrototypeSource
	^ 'boolean true()'! !

!XPathTrueFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:53'!
function
	^ true! !

Object subclass: #XPathFunctionPrototype
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFunctionPrototype commentStamp: 'monty 9/28/2016 02:23' prior: 0!
An immutable class for storing the function return type, name, and argument number and types parsed from a function prototype source string.!

!XPathFunctionPrototype class methodsFor: 'instance creation' stamp: 'monty 9/23/2016 13:19'!
returnType: aReturnType functionName: aName minArguments: aMinimum maxArguments: aMaximum argumentTypes: anArgumentTypeCollection
	^ self new
		setReturnType: aReturnType
		functionName: aName
		minArguments: aMinimum
		maxArguments: aMaximum
		argumentTypes: anArgumentTypeCollection! !

!XPathFunctionPrototype methodsFor: 'testing' stamp: 'monty 10/7/2016 00:18'!
acceptsArguments
	^ self minArguments > 0
		or: [self maxArguments isNil
			or: [self maxArguments > 0]]! !

!XPathFunctionPrototype methodsFor: 'testing' stamp: 'monty 10/9/2016 19:25'!
acceptsOptionalArguments
	^ self acceptsArguments
		and: [self minArguments ~= self maxArguments]! !

!XPathFunctionPrototype methodsFor: 'testing' stamp: 'monty 10/9/2016 19:25'!
acceptsVariableArguments
	^ self acceptsArguments
		and: [self maxArguments isNil]! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:09'!
argumentTypeAt: anIndex
	^ self
		argumentTypeAt: anIndex
		ifAbsent: [nil]! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:09'!
argumentTypeAt: anIndex ifAbsent: aBlock
	anIndex > 0
		ifFalse: [^ aBlock value].
	anIndex > self argumentTypes size
		ifTrue: [
			"If it has a variable number of arguments, then
			use the last argument type for the remaining"
			self acceptsVariableArguments
				ifTrue: [^ self argumentTypes last]
				ifFalse: [^ aBlock value]].
	^ self argumentTypes at: anIndex.! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:34'!
argumentTypes
	^ argumentTypes! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:08'!
functionName
	^ functionName! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:07'!
maxArguments
	^ maxArguments! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:07'!
minArguments
	^ minArguments! !

!XPathFunctionPrototype methodsFor: 'printing' stamp: 'monty 9/23/2016 13:47'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self returnType name asString;
		space;
		nextPutAll: self functionName;
		nextPut: $(.
	self argumentTypes withIndexDo: [:each :i |
		i > 1
			ifTrue: [aStream nextPutAll: ', '].
		aStream nextPutAll: each name asString.
		i > self minArguments
			ifTrue: [
				self maxArguments
					ifNil: [aStream nextPut: $*]
					ifNotNil: [aStream nextPut: $?]]].
	aStream nextPutAll: '))'.! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:07'!
returnType
	^ returnType! !

!XPathFunctionPrototype methodsFor: 'initialization' stamp: 'monty 9/23/2016 13:19'!
setReturnType: aReturnType functionName: aName minArguments: aMinimum maxArguments: aMaximum argumentTypes: anArgumentTypeCollection
	returnType := aReturnType.
	functionName := aName.
	minArguments := aMinimum.
	maxArguments := aMaximum.
	argumentTypes := anArgumentTypeCollection asArray.! !

Object subclass: #XPathNodeSetSorter
	instanceVariableNames: 'nodeSet nodeSetSize nodeSetCollection nodeSetSet mustVisitNamespaces mustVisitAttributes totalSorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNodeSetSorter commentStamp: 'monty 10/16/2015 01:17' prior: 0!
This class sorts an unsorted node set into document order in linear time by traversing the document or just the nodes of a shared parent. (faster in tests on average than #sort: with a backtracking node order comparison block)!

!XPathNodeSetSorter class methodsFor: 'instance creation' stamp: 'monty 6/9/2015 01:45'!
on: aNodeSet
	^ self new on: aNodeSet! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 6/11/2015 02:05'!
errorNodesLackSharedDocumentRoot
	XPathDOMException signal: 'Cannot sort nodes without shared document root'! !

!XPathNodeSetSorter methodsFor: 'initialization' stamp: 'monty 9/22/2016 10:20'!
on: aNodeSet
	"save the internal state of the node set to inst vars for
	performance and to simplify code"
	nodeSet := aNodeSet.
	nodeSetSize := aNodeSet size.
	nodeSetCollection := aNodeSet collection.
	nodeSetSet := aNodeSet set.

	mustVisitNamespaces := false.
	mustVisitAttributes := false.
	totalSorted := 0.! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 9/22/2016 10:29'!
prescanNodesForSharedParent
	"check if all nodes in the node set have the same parent so sorting
	can be done quicker and if there are no attributes or namespaces
	in the node set so they can be ignored during sorting"

	| sharedParent |

	sharedParent := nodeSetCollection first parent.
	nodeSetCollection do: [:each |
		each isNamespace
			ifTrue: [mustVisitNamespaces := true]
			ifFalse: [
				each isAttribute
					ifTrue: [mustVisitAttributes := true]].
		sharedParent
			ifNotNil: [
				each parent == sharedParent
					ifFalse: [sharedParent := nil]]].
	^ sharedParent.! !

!XPathNodeSetSorter methodsFor: 'sorting' stamp: 'monty 9/22/2016 10:21'!
sort
	nodeSetSize > 1
		ifTrue: [
			self prescanNodesForSharedParent
				ifNil: [self sortVisitingAllNodes]
				ifNotNil: [:parent | self sortVisitingNodesOfSharedParent: parent]].
	nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 9/22/2016 10:43'!
sortVisitingAllNodes
	nodeSetCollection first documentRoot allNodesDo: [:node |
		self visitNode: node.
		node isElement
			ifTrue: [
				(mustVisitNamespaces
					and: [node hasNamespaceNodes])
					ifTrue: [node namespaceNodesDo: [:each | self visitNode: each]].
				(mustVisitAttributes
					and: [node hasAttributes])
					ifTrue: [node attributeNodesDo: [:each |self visitNode: each]]].
		"can abort when every node in the node set has been visited"
		totalSorted = nodeSetSize
			ifTrue: [^ self]].

	"if we got here, then at least one node must not belong to the same
	document as the rest, because otherwise it would have been visited"
	self errorNodesLackSharedDocumentRoot.! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 9/22/2016 10:42'!
sortVisitingNodesOfSharedParent: aParent
	"all nodes in the node set have the same parent, so only its
	namespaces and attributes (if any are in the node set) and
	children need to be visited"
	mustVisitNamespaces
		ifTrue: [aParent namespaceNodesDo: [:each | self visitNode: each]].
	mustVisitAttributes
		ifTrue: [aParent attributeNodesDo: [:each | self visitNode: each]].
	aParent hasChildren
		ifTrue: [aParent nodesDo: [:each | self visitNode: each]].! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 9/22/2016 10:09'!
visitNode: aNode
	(nodeSetSet includes: aNode)
		ifTrue: [
			nodeSetCollection
				at: (totalSorted := totalSorted + 1)
				put: aNode]! !

Object subclass: #XPathNodeTestParserContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

XPathNodeTestParserContext class
	instanceVariableNames: 'instance'!

!XPathNodeTestParserContext commentStamp: 'monty 4/12/2015 11:26' prior: 0!
This is an abstract base class for node test parser contexts. Instances of subclasses are immutable and shared.!

XPathNodeTestParserContext class
	instanceVariableNames: 'instance'!

XPathNodeTestParserContext subclass: #XPathNodeTestParserAttributeContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserAttributeContext commentStamp: 'monty 4/11/2015 04:14' prior: 0!
A context for parsing node tests where attributes are the principal node type.!

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForAttributeWithAnyName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:47'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForAttributeWithLocalName: aLocalName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 13:26'!
handleTestForName: aName with: aHandler
	aHandler handleTestForAttributeWithName: aName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForAttributeWithNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 4/15/2015 08:00'!
handleTestForNamespaceURI: aURI with: aHandler
	aHandler handleTestForAttributeWithNamespaceURI: aURI! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:43'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForAttributeWithPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:06'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForAttributeWithPrefix: aPrefix! !

XPathNodeTestParserAttributeContext subclass: #XPathNodeTestParserAttributeTypeTestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserAttributeTypeTestContext commentStamp: 'monty 4/11/2015 04:14' prior: 0!
A context for parsing the arguments of an attribute() type test.!

!XPathNodeTestParserAttributeTypeTestContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:27'!
handleEmptyTestWith: aHandler
	aHandler handleTestForAttributeWithAnyName! !

!XPathNodeTestParserContext class methodsFor: 'accessing' stamp: 'monty 10/9/2016 04:57'!
instance
	^ instance
		ifNil: [instance := self basicNew initialize]! !

!XPathNodeTestParserContext class methodsFor: 'instance creation' stamp: 'monty 10/9/2016 04:59'!
new
	"these classes are immutable and shared, so they are only initialized once"
	^ self instance! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:25'!
handleEmptyTestWith: aHandler
	aHandler handleEmptyTest! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:26'!
handleTestForAnyNodeTypeWith: aHandler
	aHandler handleTestForAnyNodeType! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:25'!
handleTestForCommentTypeWith: aHandler
	aHandler handleTestForCommentType! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:46'!
handleTestForLocalName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:18'!
handleTestForName: aName with: aHandler
	self subclassResponsibility
! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/15/2015 07:32'!
handleTestForNamespaceURI: aURI with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:41'!
handleTestForPITypeWith: aHandler
	aHandler handleTestForPIWithAnyName! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:25'!
handleTestForPIWithName: aName with: aHandler
	aHandler handleTestForPIWithName: aName! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:42'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForPrefix: aPrefix with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:26'!
handleTestForTextTypeWith: aHandler
	aHandler handleTestForTextType! !

XPathNodeTestParserContext subclass: #XPathNodeTestParserElementContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserElementContext commentStamp: 'monty 4/11/2015 03:43' prior: 0!
A context for parsing node tests where elements are the principal node type.!

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForElementWithAnyName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:47'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForElementWithLocalName: aLocalName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 13:27'!
handleTestForName: aName with: aHandler
	aHandler handleTestForElementWithName: aName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForElementWithNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 4/15/2015 08:00'!
handleTestForNamespaceURI: aURI with: aHandler
	aHandler handleTestForElementWithNamespaceURI: aURI! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:43'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForElementWithPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:04'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForElementWithPrefix: aPrefix! !

XPathNodeTestParserElementContext subclass: #XPathNodeTestParserElementTypeTestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserElementTypeTestContext commentStamp: 'monty 4/11/2015 04:14' prior: 0!
A context for parsing the arguments of an element() type test.!

!XPathNodeTestParserElementTypeTestContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:28'!
handleEmptyTestWith: aHandler
	aHandler handleTestForElementWithAnyName! !

XPathNodeTestParserContext subclass: #XPathNodeTestParserNamespaceContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserNamespaceContext commentStamp: 'monty 4/11/2015 03:43' prior: 0!
A context for parsing node tests where namespaces are the principal node type.!

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:28'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForNamespaceWithAnyName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:29'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForNamespaceWithLocalName: aLocalName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:29'!
handleTestForName: aName with: aHandler
	aHandler handleTestForNamespaceWithName: aName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:29'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForNamespaceWithNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/15/2015 08:00'!
handleTestForNamespaceURI: aURI with: aHandler
	aHandler handleTestForNamespaceWithNamespaceURI: aURI! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:30'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForNamespaceWithPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:30'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForNamespaceWithPrefix: aPrefix! !

XPathNodeTestParserNamespaceContext subclass: #XPathNodeTestParserNamespaceTypeTestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserNamespaceTypeTestContext commentStamp: 'monty 4/14/2015 10:09' prior: 0!
A context for parsing the arguments of a namespace() type test.!

!XPathNodeTestParserNamespaceTypeTestContext methodsFor: 'handling' stamp: 'monty 4/14/2015 10:08'!
handleEmptyTestWith: aHandler
	aHandler handleTestForNamespaceWithAnyName! !

Object subclass: #XPathNodeTestWithFilters
	instanceVariableNames: 'filters nodeTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNodeTestWithFilters commentStamp: 'monty 2/24/2016 10:57' prior: 0!
This class stores a node test block and an array of filter blocks or positions.!

!XPathNodeTestWithFilters class methodsFor: 'instance creation' stamp: 'monty 9/3/2016 21:08'!
nodeTest: aNodeTestBlock
	^ self
		nodeTest: aNodeTestBlock
		filters: #()! !

!XPathNodeTestWithFilters class methodsFor: 'instance creation' stamp: 'monty 9/3/2016 21:13'!
nodeTest: aNodeTestBlock filters: aFilterCollection
	^ self new
		setNodeTest: aNodeTestBlock
		filters: aFilterCollection! !

!XPathNodeTestWithFilters methodsFor: 'converting' stamp: 'monty 2/24/2016 10:55'!
asXPathAttributeNodeTestBlock
	^ nodeTest! !

!XPathNodeTestWithFilters methodsFor: 'converting' stamp: 'monty 2/24/2016 10:55'!
asXPathNamespaceNodeTestBlock
	^ nodeTest! !

!XPathNodeTestWithFilters methodsFor: 'converting' stamp: 'monty 2/24/2016 10:55'!
asXPathNodeSetFilters
	^ filters! !

!XPathNodeTestWithFilters methodsFor: 'converting' stamp: 'monty 2/24/2016 10:55'!
asXPathNodeTestBlock
	^ nodeTest! !

!XPathNodeTestWithFilters methodsFor: 'private' stamp: 'monty 9/4/2016 01:39'!
filterWithAll: aFilterCollection
	"instead of filtering anything, this stores the filters so the
	node test and filters can be applied by an axis later"
	filters := aFilterCollection! !

!XPathNodeTestWithFilters methodsFor: 'testing' stamp: 'monty 2/24/2016 10:55'!
hasXPathNodeSetFilters
	^ filters notEmpty! !

!XPathNodeTestWithFilters methodsFor: 'printing' stamp: 'monty 3/5/2016 14:04'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: nodeTest.
	filters
		ifNotNil: [
			aStream
				space
				print: filters].
	aStream nextPut: $).! !

!XPathNodeTestWithFilters methodsFor: 'initialization' stamp: 'monty 9/4/2016 01:39'!
setNodeTest: aNodeTestBlock filters: aFilterCollection
	nodeTest := aNodeTestBlock.
	filters := aFilterCollection.! !

Object subclass: #XPathParser
	instanceVariableNames: 'handler inputStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParser commentStamp: 'monty 4/2/2016 02:43' prior: 0!
This is an abstract class for XPath parsers that parse input using injectable parser handlers.!

XPathParser subclass: #XPathExpressionParser
	instanceVariableNames: 'currentAxis nodeTestParser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParser commentStamp: 'monty 2/10/2015 02:58' prior: 0!
This class parses XPath expressions. It understands all of XPath 1.0 syntax and supports some extensions like abbreviated syntax for other axis specifiers.!

!XPathExpressionParser methodsFor: 'testing' stamp: 'monty 6/17/2015 00:58'!
atDigit
	inputStream peek
		ifNil: [^ false]
		ifNotNil: [:nextChar | ^ nextChar isDigit]! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 4/2/2015 08:19'!
errorExpectedEndPredicate
	self errorExpected: '"]" end of predicate'! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/21/2015 18:29'!
errorExpectedNodeTest
	self errorExpected: 'node test after axis'! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/14/2015 04:35'!
errorExpectedStep
	self errorExpected: 'location path step'! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/26/2015 20:32'!
nextAdditionalSteps
	self peekForAdditionalSteps
		ifFalse: [self errorExpectedStep]! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 10:48'!
nextAdditiveExpression
	handler handleStartAdditiveExpression.
	self nextMultiplicativeExpression.
	[self peekForAdditiveOperator]
		whileTrue: [self nextMultiplicativeExpression].
	handler handleEndAdditiveExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/22/2016 11:11'!
nextAndExpression
	handler handleStartAndExpression.
	self nextEqualityExpression.
	[self peekForAndOperator]
		whileTrue: [
			handler handleAnd.
			self nextEqualityExpression].
	handler handleEndAndExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:19'!
nextArgument
	handler handleStartFunctionArgument.
	self nextOrExpression.
	handler handleEndFunctionArgument.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/18/2015 15:21'!
nextDigitsOnWriteStream
	"first digit"
	writeStream nextPut: inputStream next.
	[self atDigit]
		whileTrue: [writeStream nextPut: inputStream next].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 11:10'!
nextEqualityExpression
	handler handleStartEqualityExpression.
	self nextRelationalExpression.
	[self peekForEqualityOperator]
		whileTrue: [self nextRelationalExpression].
	handler handleEndEqualityExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 10/28/2015 15:54'!
nextFilterExpression
	handler handleStartFilterExpression.
	self
		nextPrimaryExpression;
		peekForPredicates.
	handler handleEndFilterExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:17'!
nextFunctionCall
	| name |

	name := self nextName.
	name = 'position'
		ifTrue: [
			handler handlePositionFunctionCall.
			^ self nextEmptyArgumentList].
	name = 'last'
		ifTrue: [
			handler handleLastFunctionCall.
			^ self nextEmptyArgumentList].

	handler handleStartFunctionCall: name.
	self nextArgumentList.
	handler handleEndFunctionCall.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 07:43'!
nextMultiplicativeExpression
	handler handleStartMultiplicativeExpression.
	self nextUnaryExpression.
	[self peekForMultiplicativeOperator]
		whileTrue: [self nextUnaryExpression].
	handler handleEndMultiplicativeExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/22/2016 11:11'!
nextOrExpression
	handler handleStartOrExpression.
	self nextAndExpression.
	[self peekForOrOperator]
		whileTrue: [
			handler handleOr.
			self nextAndExpression].
	handler handleEndOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 10/27/2015 17:44'!
nextPathExpression
	handler handleStartPathExpression.
	self peekForLocationPathExpression
		ifFalse: [
			self nextFilterExpression.
			self peekForLocationPathSeparator
				ifTrue: [
					handler handleStartFilterExpressionLocationPath.
					self nextAdditionalSteps]].
	handler handleEndPathExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/23/2016 07:03'!
nextPredicateBody
	inputStream skipSeparators.
	(self peekForIntegerPredicate
		or: [self peekForAttributePredicate])
		ifFalse: [
			handler handleStartPredicate.
			self nextOrExpression.
			self peekForEndPredicate
				ifFalse: [self errorExpectedEndPredicate].
			handler handleEndPredicate].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/20/2015 19:39'!
nextPrimaryExpression
	inputStream skipSeparators.
	(self peekForVariableReference
		or: [self peekForParenthesizedExpression
			or: [self peekForStringLiteral
				or: [self peekForNumber]]])
		ifFalse: [self nextFunctionCall].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:46'!
nextRelationalExpression
	handler handleStartRelationalExpression.
	self nextAdditiveExpression.
	[self peekForRelationalOperator]
		whileTrue: [self nextAdditiveExpression].
	handler handleEndRelationalExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 22:10'!
nextUnaryExpression
	| totalNegations |

	handler handleStartUnaryExpression.
	totalNegations := 0.
	[self peekForNegationOperator]
		whileTrue: [totalNegations := totalNegations + 1].
	totalNegations odd
		ifTrue: [handler handleNegation].
	self nextUnionExpression.
	handler handleEndUnaryExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:07'!
nextUnionExpression
	handler handleStartUnionExpression.
	self nextPathExpression.
	[self peekForUnion]
		whileTrue: [self nextPathExpression].
	handler handleEndUnionExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/21/2016 12:51'!
parseInput
	currentAxis := XPathAxis new.
	nodeTestParser :=
		XPathNodeTestParser
			on: inputStream
			for:
				(XPathCompilingNodeTestParserHandler
					currentAxis: currentAxis
					expressionParserHandler: handler).
	self nextOrExpression.! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 2/10/2015 22:11'!
peekFailedAt: aPosition
	inputStream position: aPosition.
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 12/23/2016 21:05'!
peekForAbbreviatedAxis
	(inputStream peekFor: $@)
		ifTrue: [
			currentAxis axisSpecifier: 'attribute'.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 10/7/2015 03:33'!
peekForAbbreviatedDescendantStep
	(inputStream peekFor: $/)
		ifFalse: [^ false].

	currentAxis axisSpecifier: 'descendant-or-self'.
	self startNodeTestForAnyNodeType.
	self peekForStep
		ifFalse: [self errorExpectedStep].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 11/18/2015 22:16'!
peekForAbbreviatedStep
	(inputStream peekFor: $.)
		ifFalse: [^ false].
	self atDigit "float literal"
		ifTrue: [
			inputStream skipBack.
			^ false].

	(inputStream peekFor: $.)
		ifTrue: [currentAxis axisSpecifier: 'parent']
		ifFalse: [
			currentAxis isFirstAxis
				ifFalse: [
					"can be omitted"
					currentAxis beDefaultImplicitAxis.
					^ true].
			currentAxis axisSpecifier: 'self'].
	"abbreviated steps cannot have filters"
	self startNodeTestForAnyNodeType.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 11/18/2015 22:16'!
peekForAbsoluteLocationPath
	self peekForLocationPathSeparator
		ifFalse: [^ false].

	handler handleStartAbsoluteLocationPath.
	currentAxis
		beDefaultImplicitAxis;
		beFirstAxis.
	self peekForAdditionalSteps
		ifFalse: [
			currentAxis axisSpecifier: 'self'.
			self startNodeTestForAnyNodeType].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/16/2015 05:34'!
peekForAdditionalSteps
	(self peekForAbbreviatedDescendantStep
		or: [self peekForStep])
		ifFalse: [^ false].
	[self peekForLocationPathSeparator]
		whileTrue: [
			(self peekForAbbreviatedDescendantStep
				or: [self peekForStep])
				ifFalse: [self errorExpectedStep]].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/12/2015 05:10'!
peekForAdditiveOperator
	inputStream skipSeparators.
	(inputStream peekFor: $+)
		ifTrue: [
			handler handleAddition.
			^ true].
	(inputStream peekFor: $-)
		ifTrue: [
			handler handleSubtraction.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 7/22/2016 02:49'!
peekForAndOperator
	^ inputStream
		skipSeparators;
		nextMatchAll: 'and'! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/2/2015 04:38'!
peekForAttributePredicate
	| startPosition namePosition ncName isNotEquals stringLiteral |

	startPosition := inputStream position.
	(inputStream peekFor: $@)
		ifFalse: [^ false].

	inputStream skipSeparators.
	namePosition := inputStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ self peekFailedAt: startPosition].

	inputStream skipSeparators.
	isNotEquals := inputStream peekFor: $!!.
	(inputStream peekFor: $=)
		ifTrue: [
			inputStream skipSeparators.
			((stringLiteral := self nextStringLiteralOptional: true) notNil
				and: [self peekForEndPredicate])
				ifTrue: [
					isNotEquals
						ifTrue: [
							handler
								handlePredicateAttribute: ncName
								notEqualsStringLiteral: stringLiteral]
						ifFalse: [
							handler
								handlePredicateAttribute: ncName
								equalsStringLiteral: stringLiteral].
					^ true]].
	inputStream
		pushBackNCName: ncName
		position: namePosition.
	^ self peekFailedAt: startPosition.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/26/2015 14:58'!
peekForAxis
	| startPosition ncName |

	self peekForAbbreviatedAxis
		ifTrue: [^ true].
	startPosition := inputStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ false].
	inputStream skipSeparators.
	((inputStream peekFor: $:)
		and: [inputStream peekFor: $:])
		ifFalse: [
			inputStream
				pushBackNCName: ncName
				position: startPosition.
			^ false].
	currentAxis axisSpecifier: ncName.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 7/22/2016 02:49'!
peekForEndPredicate
	^ inputStream
		skipSeparators;
		peekFor: $]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/1/2016 06:18'!
peekForEqualityOperator
	inputStream skipSeparators.
	(inputStream nextMatchAll: '!!=')
		ifTrue: [
			handler handleNotEquals.
			^ true].
	(inputStream peekFor: $=)
		ifTrue: [
			handler handleEquals.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:33'!
peekForIntegerPredicate
	| startPosition |

	self atDigit
		ifFalse: [^ false].
	
	startPosition := inputStream position.
	writeStream reset.
	self nextDigitsOnWriteStream.
	self peekForEndPredicate
		ifTrue: [
			handler handleIntegerPredicate: writeStream contents.
			^ true]
		ifFalse: [^ self peekFailedAt: startPosition].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/22/2015 22:21'!
peekForLocationPathExpression
	^ self peekForAbsoluteLocationPath
		or: [self peekForRelativeLocationPath]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 7/22/2016 02:49'!
peekForLocationPathSeparator
	^ inputStream
		skipSeparators;
		peekFor: $/! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/1/2016 06:18'!
peekForMultiplicativeOperator
	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [^ false].
	(inputStream peekFor: $*)
		ifTrue: [
			handler handleMultiplication.
			^ true].
	(inputStream nextMatchAll: 'div')
		ifTrue: [
			handler handleDivision.
			^ true].
	(inputStream nextMatchAll: 'mod')
		ifTrue: [
			handler handleModulus.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 7/22/2016 02:49'!
peekForNegationOperator
	^ inputStream
		skipSeparators;
		peekFor: $-! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 11/19/2015 16:44'!
peekForNumber
	| startPosition |

	startPosition := inputStream position.
	writeStream reset.
	self atDigit
		ifTrue: [
			self nextDigitsOnWriteStream.
			(inputStream peekFor: $.)
				ifTrue: [
					"Smalltalk float literals can't have a trailing '.' like in '1. + 1'"
					self atDigit
						ifTrue: [
							writeStream nextPut: $..
							self nextDigitsOnWriteStream]].
			handler handleNumberLiteral: writeStream contents.
			^ true].
	((inputStream peekFor: $.)
		and: [self atDigit])
		ifTrue: [
			"Smalltalk float literals can't have a leading '.' like in '1 + .1'"
			writeStream nextPutAll: '0.'.
			self nextDigitsOnWriteStream.
			handler handleNumberLiteral: writeStream contents.
			^ true].
	^ self peekFailedAt: startPosition.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 7/22/2016 02:48'!
peekForOrOperator
	^ inputStream
		skipSeparators;
		nextMatchAll: 'or'! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:41'!
peekForParenthesizedExpression
	(inputStream peekFor: $()
		ifFalse: [^ false].

	self nextOrExpression.
	inputStream skipSeparators.
	self expectNext: $).
	^ true.
! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/23/2016 07:04'!
peekForPredicate
	self peekForStartPredicate
		ifTrue: [
			self nextPredicateBody.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/23/2016 07:04'!
peekForPredicates
	self peekForStartPredicate
		ifTrue: [
			handler handleStartPredicates.
			self nextPredicateBody.
			[self peekForPredicate] whileTrue.
			handler handleEndPredicates.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/13/2015 11:48'!
peekForRelationalOperator
	inputStream skipSeparators.
	(inputStream peekFor: $<)
		ifTrue: [
			(inputStream peekFor: $=)
				ifTrue: [handler handleLessThanOrEqualTo]
				ifFalse: [handler handleLessThan].
			^ true].
	(inputStream peekFor: $>)
		ifTrue: [
			(inputStream peekFor: $=)
				ifTrue: [handler handleGreaterThanOrEqualTo]
				ifFalse: [handler handleGreaterThan].
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 11/18/2015 22:16'!
peekForRelativeLocationPath
	currentAxis
		beDefaultImplicitAxis;
		beFirstAxis;
		beStartOfRelativeLocationPath.
	self peekForStep
		ifFalse: [^ false].
	self peekForLocationPathSeparator
		ifTrue: [self nextAdditionalSteps].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 7/22/2016 02:48'!
peekForStartPredicate
	^ inputStream
		skipSeparators;
		peekFor: $[! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 11/18/2015 22:16'!
peekForStep
	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [^ false].

	self peekForAbbreviatedStep
		ifTrue: [^ true].

	self peekForAxis.
	nodeTestParser parse
		ifTrue: [
			self peekForPredicates.
			handler handleEndStep.
			^ true]
		ifFalse: [
			currentAxis isImplicitAxis
				ifFalse: [self errorExpectedNodeTest].
			currentAxis beDefaultImplicitAxis.
			^ false].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/21/2015 07:12'!
peekForStringLiteral
	(self nextStringLiteralOptional: true)
		ifNil: [^ false]
		ifNotNil: [:string |
			handler handleStringLiteral: string.
			^ true]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:36'!
peekForUnion
	inputStream skipSeparators.
	(inputStream peekFor: $|)
		ifTrue: [
			handler handleUnion.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:36'!
peekForVariableReference
	(inputStream peekFor: $$)
		ifTrue: [
			handler handleVariableReference: self nextName.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 11/18/2015 22:16'!
startNodeTestForAnyNodeType
	currentAxis isStartOfRelativeLocationPath
		ifTrue: [handler handleStartRelativeLocationPath].
	handler
		handleStartStep;
		handleAxis: currentAxis;
		handleTestForAnyNodeType;
		handleEndStep.
	currentAxis beDefaultImplicitAxis.! !

XPathParser subclass: #XPathFunctionPrototypeParser
	instanceVariableNames: 'hasOptionalArgument hasUnboundedArgument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathFunctionPrototypeParser commentStamp: 'monty 6/5/2015 01:09' prior: 0!
This class parses XPath function prototypes to extract the name, return type, and the number and type of arguments.!

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorArgumentAfterUnboundedArgument
	XPathSyntaxException signal: 'Argument after unbounded "*" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorNonOptionalArgumentAfterOptional
	XPathSyntaxException signal: 'Non-optional argument afer optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:23'!
errorUnboundedArgumentAfterOptional
	XPathSyntaxException signal: 'Unbounded "*" argument after optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/22/2016 04:43'!
nextArgument
	hasUnboundedArgument
		ifTrue: [self errorArgumentAfterUnboundedArgument].

	inputStream skipSeparators.
	self nextModifierForArgument: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:38'!
nextFunctionName
	inputStream skipSeparators.
	handler handleFunctionName: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/22/2016 04:46'!
nextModifierForArgument: anArgument
	inputStream skipSeparators.
	(inputStream peekFor: $*)
		ifTrue: [
			hasOptionalArgument
				ifTrue: [self errorUnboundedArgumentAfterOptional].
			hasUnboundedArgument := true.
			handler handleUnboundedArgument: anArgument]
		ifFalse: [
			(inputStream peekFor: $?)
				ifTrue: [
					hasOptionalArgument := true.
					handler handleOptionalArgument: anArgument]
				ifFalse: [
					hasOptionalArgument
						ifTrue: [self errorNonOptionalArgumentAfterOptional].
					handler handleArgument: anArgument]].! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:37'!
nextReturnType
	inputStream skipSeparators.
	handler handleReturnType: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/22/2016 04:45'!
parseInput
	hasOptionalArgument := false.
	hasUnboundedArgument := false.
	self
		nextReturnType;
		nextFunctionName;
		nextArgumentList! !

XPathParser subclass: #XPathNodeTestParser
	instanceVariableNames: 'context isParsingNodeTypeTest'
	classVariableNames: 'NodeTypeTestParserSelectors'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParser commentStamp: 'monty 4/2/2016 02:44' prior: 0!
This class parses node tests that are either node name tests like 'name' and '*' or node type tests like 'node()' and 'comment()'.!

!XPathNodeTestParser class methodsFor: 'class initialization' stamp: 'monty 9/28/2016 22:32'!
initialize 
	"self initialize"

	"assign after with #yourself to avoid possible race
	conditions when reinitializing the class"
	NodeTypeTestParserSelectors :=
		Dictionary new
			at: 'comment' put: #nextCommentTypeTest;
			at: 'text' put: #nextTextTypeTest;
			at: 'processing-instruction' put: #nextPITypeTest;
			at: 'node' put: #nextAnyNodeTypeTest;
			at: 'element' put: #nextElementTypeTest;
			at: 'attribute' put: #nextAttributeTypeTest;
			at: 'namespace' put: #nextNamespaceTypeTest;
			yourself! !

XPathNodeTestParser initialize!

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/1/2015 08:44'!
nextAnyNodeTypeTest
	self nextEndArgumentList.
	context handleTestForAnyNodeTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 4/10/2015 04:15'!
nextAttributeTypeTest
	context := XPathNodeTestParserAttributeTypeTestContext new.
	self
		peekForNodeTest;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 2/27/2015 13:46'!
nextCommentTypeTest
	self nextEndArgumentList.
	context handleTestForCommentTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 4/10/2015 04:15'!
nextElementTypeTest
	context := XPathNodeTestParserElementTypeTestContext new.
	self
		peekForNodeTest;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 2/22/2015 11:26'!
nextEmptyTest
	context handleEmptyTestWith: handler! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 4/14/2015 10:09'!
nextNamespaceTypeTest
	context := XPathNodeTestParserNamespaceTypeTestContext new.
	self
		peekForNodeTest;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/5/2015 08:15'!
nextPITypeTest
	| name |

	inputStream skipSeparators.
	name :=
		(self nextStringLiteralOptional: true)
			ifNil: [self nextNCNameOptional: true].
	name
		ifNil: [context handleTestForPITypeWith: handler]
		ifNotNil: [
			context
				handleTestForPIWithName: name
				with: handler].
	self nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/1/2015 11:11'!
nextTextTypeTest
	self nextEndArgumentList.
	context handleTestForTextTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/31/2016 22:38'!
parseInput
	context := handler defaultNodeTestParserContextClass new.
	isParsingNodeTypeTest := false.
	self peekForNodeTest.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/15/2015 07:33'!
peekForExpandedNameTest: aName
	(aName = 'Q'
		and: [inputStream peekFor: ${])
		ifTrue: [| uri |
			uri := self expectUpTo: $}.
			(inputStream peekFor: $*)
				ifTrue: [
					context
						handleTestForNamespaceURI: uri
						with: handler]
				ifFalse: [
					context
						handleTestForNamespaceURI: uri
						localName: self nextNCName
						with: handler].
			^ true]
		ifFalse: [^ false]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/31/2016 22:38'!
peekForNameTestOrNoteTypeTest: aLocalName
	inputStream skipSeparators.
	(inputStream peekFor: $:)
		ifTrue: [^ false]. ": after spaces; axis specifier"

	(isParsingNodeTypeTest not
		and: [self peekForStartArgumentList])
		ifTrue: [^ self peekForNodeTypeTest: aLocalName]
		ifFalse: [
			context
				handleTestForName: aLocalName
				with: handler.
			^ true].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/3/2015 17:39'!
peekForNameTestStartingWith: anNcName
	(inputStream peekFor: $:)
		ifTrue: [
			inputStream peek == $: ":: axis specifier"
				ifTrue: [^ false]
				ifFalse: [^ self peekForQualifiedNameTestWithPrefix: anNcName]]
		ifFalse: [
			^ (self peekForExpandedNameTest: anNcName)
				or: [self peekForNameTestOrNoteTypeTest: anNcName]]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 04:54'!
peekForNodeTest
	inputStream skipSeparators.
	(inputStream atEnd not
		and: [self peekForWildCardNameTest
			or: [self peekForNonWildCardNameTest]])
		ifTrue: [^ true]
		ifFalse: [
			self nextEmptyTest.
			^ false]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/31/2016 22:38'!
peekForNodeTypeTest: aNodeTypeOrFunctionName
	| nodeTypeTestParserSelector |

	nodeTypeTestParserSelector :=
		NodeTypeTestParserSelectors
			at: aNodeTypeOrFunctionName
			ifAbsent: [^ false].
	isParsingNodeTypeTest := true.
	self perform: nodeTypeTestParserSelector.
	isParsingNodeTypeTest := false.
	^ true.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/28/2015 14:29'!
peekForNonWildCardNameTest
	| startPosition ncName |

	startPosition := inputStream position.
	((ncName := self nextNCNameOptional: true) notNil
		and: [self peekForNameTestStartingWith: ncName])
		ifTrue: [^ true]
		ifFalse: [
			ncName
				ifNotNil: [
					inputStream
						pushBackNCName: ncName
						position: startPosition].
			^ false].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 11:42'!
peekForQualifiedNameTestWithPrefix: aPrefix
	(inputStream peekFor: $*)
		ifTrue: [
			context
				handleTestForPrefix: aPrefix
				with: handler.
			^ true]
		ifFalse: [| localName |
			localName := self nextNCName.
			self peekForStartArgumentList "function"
				ifTrue: [^ false]
				ifFalse: [
					context
						handleTestForPrefix: aPrefix
						localName: localName
						with: handler.
					^ true]].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/27/2015 05:24'!
peekForStartArgumentList
	inputStream skipSeparators.
	^ inputStream peekFor: $(.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 11:46'!
peekForWildCardNameTest
	(inputStream peekFor: $*)
		ifFalse: [^ false].

	(inputStream peekFor: $:)
		ifTrue: [
			(inputStream peekFor: $*)
				ifTrue: [context handleTestForAnyNameWith: handler]
				ifFalse: [
					context
						handleTestForLocalName: self nextNCName
						with: handler]]
		ifFalse: [context handleTestForAnyNameWith: handler].
	^ true.! !

!XPathParser class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 06:01'!
on: aStringOrStream for: aHandler
	^ self new
		on: aStringOrStream
		for: aHandler! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:27'!
endParsing
	handler handleEndParsing.
	handler mustBeAtEndAfterParsing
		ifTrue: [	
			inputStream skipSeparators.
			inputStream atEnd
				ifFalse: [self errorExpectedAtEnd]].! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpected: aString
	XPathSyntaxException
		formatSignal: 'Expected {1}'
		with: aString! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:53'!
errorExpectedAtEnd
	self errorExpected: 'end of input'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpectedLiteral: anExpectedCharacterOrString butGot: aReceivedCharacterOrString
	XPathSyntaxException
		formatSignal: 'Expected "{1}" but got "{2}"'
		with: anExpectedCharacterOrString
		with: (aReceivedCharacterOrString ifNil: [''])! !

!XPathParser methodsFor: 'private' stamp: 'monty 3/25/2016 22:00'!
errorExpectedName
	self errorExpected: 'an XPath qualified or non-qualified name'! !

!XPathParser methodsFor: 'private' stamp: 'monty 3/10/2015 19:48'!
errorExpectedStringLiteral
	self errorExpected: 'single or double quoted string literal'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/18/2015 14:06'!
expectNext: aCharacter
	| nextChar |

	((nextChar := inputStream next) == aCharacter)
		ifFalse: [
			self
				errorExpectedLiteral: aCharacter
				butGot: nextChar].
	^ aCharacter.! !

!XPathParser methodsFor: 'private' stamp: 'monty 12/6/2016 09:45'!
expectUpTo: aCharacter
	writeStream reset.
	[inputStream atEnd
		or: [inputStream peek = aCharacter]]
		whileFalse: [writeStream nextPut: inputStream next].
	self expectNext: aCharacter.
	^ writeStream contents.! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
handler
	^ handler! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
inputStream
	^ inputStream! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/15/2015 22:25'!
nextArgument
	"override to parse arguments in function argument lists"! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:26'!
nextArgumentList
	"a template method; nextArgument must be overriden to handle arguments"
	self nextStartArgumentList.
	self peekForEndArgumentList
		ifFalse: [
			self nextArgument.
			[self peekForArgumentSeparator]
				whileTrue: [self nextArgument].
			self nextEndArgumentList].! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:20'!
nextEmptyArgumentList
	self
		nextStartArgumentList;
		nextEndArgumentList
! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:19'!
nextEndArgumentList
	inputStream skipSeparators.
	self expectNext: $).! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 03:46'!
nextNCName
	^ self nextNCNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/25/2016 17:33'!
nextNCNameOptional: aBoolean
	| ncName |

	(ncName := inputStream nextNCName)
		ifNil: [
			aBoolean
				ifFalse: [self errorExpectedName]].
	^ ncName.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/2/2015 04:40'!
nextName
	^ self nextNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/25/2016 17:01'!
nextNameOptional: aBoolean
	| name |

	(name := inputStream nextName)
		ifNil: [
			aBoolean
				ifFalse: [self errorExpectedName]].
	^ name.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:19'!
nextStartArgumentList
	inputStream skipSeparators.
	self expectNext: $(.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 03:42'!
nextStringLiteral
	^ self nextStringLiteralOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:47'!
nextStringLiteralOptional: aBoolean
	(inputStream peek == $"
		or: [inputStream peek == $'])
		ifTrue: [^ self expectUpTo: inputStream next]
		ifFalse: [
			aBoolean
				ifFalse: [self errorExpectedStringLiteral].
			^ nil]! !

!XPathParser methodsFor: 'initialization' stamp: 'monty 9/22/2016 16:37'!
on: aStringOrStream for: aHandler
	inputStream :=
		(aStringOrStream isStream
			ifTrue: [aStringOrStream asXPathReadStreamAdapter]
			ifFalse: [aStringOrStream readStream asXPathReadStreamAdapter]).
	handler := aHandler.
	"must use #writeStream instead of 'WriteStream on:' to get a 0-based
	stream on Gemstone"
	writeStream := (String new: 32) writeStream.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 4/12/2015 07:27'!
parse
	[self
		startParsing;
		parseInput;
		endParsing]
		on: XPathException
		do: [:error |
			error hasPosition
				ifFalse: [error position: inputStream position].
			error pass].
	^ handler parsingResult.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 06:06'!
parseInput
	self subclassResponsibility! !

!XPathParser methodsFor: 'parsing - peeking' stamp: 'monty 4/2/2015 07:10'!
peekForArgumentSeparator
	inputStream skipSeparators.
	^ inputStream peekFor: $,.! !

!XPathParser methodsFor: 'parsing - peeking' stamp: 'monty 4/2/2015 07:10'!
peekForEndArgumentList
	inputStream skipSeparators.
	^ inputStream peekFor: $).! !

!XPathParser methodsFor: 'printing' stamp: 'monty 11/19/2015 22:23'!
printOn: aStream
	super printOn: aStream.
	handler
		ifNotNil: [
			aStream
				nextPut: $(;
				print: handler;
				nextPut: $)].! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:59'!
startParsing
	handler handleStartParsing! !

Object subclass: #XPathParserHandler
	instanceVariableNames: 'parsingResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParserHandler commentStamp: 'monty 5/11/2015 00:46' prior: 0!
An abstract class for XPath parser handlers. Subclasses implement "handling" messages sent by parsers.!

XPathParserHandler subclass: #XPathExpressionParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParserHandler commentStamp: 'monty 2/22/2016 04:29' prior: 0!
An abstract class for XPath expression parser handlers.!

XPathExpressionParserHandler subclass: #XPathCompilingExpressionParserHandler
	instanceVariableNames: 'outputStream variableStack operatorStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathCompilingExpressionParserHandler commentStamp: 'monty 2/22/2016 04:31' prior: 0!
A handler class for XPath expression parsers that generates Smalltalk source implementing the XPath expression.!

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 04:16'!
contextNodeVariable
	^ self currentVariablesAt: 1! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 04:16'!
contextPositionVariable
	^ self currentVariablesAt: 2! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 04:16'!
contextSizeVariable
	^ self currentVariablesAt: 3! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/25/2016 09:20'!
contextVariable
	^ 'c'! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 4/1/2016 00:56'!
currentOperator
	^ operatorStack xmlLastOrNil! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 09:19'!
currentOperator: anOperator
	operatorStack
		at: operatorStack size
		put: anOperator.
	anOperator isString
		ifTrue: [self emitAll: anOperator]
		ifFalse: [self emit: anOperator].! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 09:30'!
currentShortCurcuitOperator: anOperator
	| association |

	"count the number of short curcuited operators"
	association :=
		operatorStack
			at: operatorStack size
			ifAbsentPut: [anOperator -> 0].
	"increment it"
	association value: (association value + 1).
	self
		emitAll: ' ';
		emitAll: association key;
		emitAll: ':['.! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:59'!
currentVariablesAt: anIndex
	^ variableStack last at: anIndex! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:38'!
emit: aCharacter
	outputStream nextPut: aCharacter! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:38'!
emitAll: aString
	outputStream nextPutAll: aString! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:38'!
emitBooleanConversion
	self emitAll: ' asXPathBoolean'! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:39'!
emitComparableConversion
	self emitAll: ' asXPathComparable'! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/25/2016 04:35'!
emitEndAttributePredicate
	self
		emitAll: ']]';
		emitEndBlock! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/25/2016 04:35'!
emitEndBlock
	self
		emit: $];
		popVariables! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/25/2016 04:28'!
emitEndShortCurcuitOperators
	self emitBooleanConversion.
	self currentOperator value timesRepeat: [
		self emit: $]].! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:39'!
emitNumberConversion
	self emitAll: ' asXPathNumber'! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 09:01'!
emitNumberLiteral: anIntegerOrFloatString
	self
		emit: $(;
		emitAll: anIntegerOrFloatString;
		emit: $)! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:39'!
emitPredicateSeparator
	self emit: $.! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:40'!
emitQuotedString: aString
	self emit: $'.
	"escape ' by outputting another ' before it"
	1 to: aString size do: [:i | | nextChar |
		(nextChar := aString at: i) == $'
			ifTrue: [self emit: $'].
		self emit: nextChar].
	self emit: $'.! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:47'!
emitStartAttributePredicate: aName
	self
		emitStartPredicateBlock;
		emitAll: self contextNodeVariable;
		emitAll: ' isElement and:[';
		emitAll: self contextNodeVariable;
		emitAll: ' hasAttributes and:[(';
		emitAll: self contextNodeVariable;
		emitAll: ' attributeAt:';
		emitQuotedString: aName;
		emit: $)! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/25/2016 09:20'!
emitStartContextBlock
	self
		pushVariables;
		emitAll: '[:';
		emitAll: self contextNodeVariable;
		emitAll: ' :';
		emitAll: self contextVariable;
		emitAll: '| |';
		emitAll: self contextPositionVariable;
		emitAll: ' ';
		emitAll: self contextSizeVariable;
		emit: $|! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:41'!
emitStartPredicateBlock
	self
		pushVariables;
		emitAll: '[:';
		emitAll: self contextNodeVariable;
		emitAll: ' :';
		emitAll: self contextPositionVariable;
		emitAll: ' :';
		emitAll: self contextSizeVariable;
		emit: $|! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 08:40'!
emitUnionableConversion
	self emitAll: ' asXPathUnionable'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleAddition
	self
		emitNumberConversion;
		currentOperator: $+! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:20'!
handleAnd
	self
		emitBooleanConversion;
		currentShortCurcuitOperator: 'and'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 09:02'!
handleAxis: anAxis
	self
		emitAll: anAxis replacementSelector;
		emit: $(! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleDivision
	self
		emitNumberConversion;
		currentOperator: $/! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:22'!
handleEndAdditiveExpression
	self hasCurrentOperator
		ifTrue: [self emitNumberConversion].
	self
		popOperator;
		emit: $).! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:21'!
handleEndAndExpression
	self hasCurrentOperator
		ifTrue: [self emitEndShortCurcuitOperators].
	self
		popOperator;
		emit: $).! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:21'!
handleEndEqualityExpression
	self hasCurrentOperator
		ifTrue: [self emitComparableConversion].
	self
		popOperator;
		emit: $).! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 09:00'!
handleEndFilterExpression
	self emit: $)! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 10/9/2016 18:56'!
handleEndFunctionArgument
	self emit: $.! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 10/5/2016 17:58'!
handleEndFunctionCall
	self emitAll: '})invoke)'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:21'!
handleEndMultiplicativeExpression
	self hasCurrentOperator
		ifTrue: [self emitNumberConversion].
	self
		popOperator;
		emit: $).! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:22'!
handleEndOrExpression
	self hasCurrentOperator
		ifTrue: [self emitEndShortCurcuitOperators].
	self
		popOperator;
		emit: $).! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling' stamp: 'monty 2/25/2016 04:36'!
handleEndParsing
	self
		emitEndBlock;
		parsingResult: outputStream contents! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 09:01'!
handleEndPathExpression
	self emit: $)! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/25/2016 04:35'!
handleEndPredicate
	self
		emitEndBlock;
		emitPredicateSeparator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/23/2016 08:46'!
handleEndPredicates
	self emit: $}! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:22'!
handleEndRelationalExpression
	self hasCurrentOperator
		ifTrue: [self emitComparableConversion].
	self
		popOperator;
		emit: $).! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 09:01'!
handleEndStep
	self emit: $)! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:22'!
handleEndUnaryExpression
	self hasCurrentOperator
		ifTrue: [self emitNumberConversion].
	self
		popOperator;
		emit: $).! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:22'!
handleEndUnionExpression
	self hasCurrentOperator
		ifTrue: [self emitUnionableConversion].
	self
		popOperator;
		emit: $).! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleEquals
	self
		emitComparableConversion;
		currentOperator: $=! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleGreaterThan
	self
		emitComparableConversion;
		currentOperator: $>! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleGreaterThanOrEqualTo
	self
		emitComparableConversion;
		currentOperator: '>='! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/23/2016 08:32'!
handleIntegerPredicate: anIntegerString
	self
		emitNumberLiteral: anIntegerString;
		emitPredicateSeparator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/23/2016 08:51'!
handleLastFunctionCall
	self
		emit: $(;
		emitAll: self contextSizeVariable;
		emitAll: ' ifNil:[1])'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleLessThan
	self
		emitComparableConversion;
		currentOperator: $<! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleLessThanOrEqualTo
	self
		emitComparableConversion;
		currentOperator: '<='! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleModulus
	self
		emitNumberConversion;
		currentOperator: '\\'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleMultiplication
	self
		emitNumberConversion;
		currentOperator: $*! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 12:45'!
handleNegation
	self
		emitNumberLiteral: '-1';
		handleMultiplication! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleNotEquals
	self
		emitComparableConversion;
		currentOperator: '!!='! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling' stamp: 'monty 2/23/2016 08:31'!
handleNumberLiteral: anIntegerOrFloatString
	self emitNumberLiteral: anIntegerOrFloatString! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:20'!
handleOr
	self
		emitBooleanConversion;
		currentShortCurcuitOperator: 'or'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/23/2016 08:51'!
handlePositionFunctionCall
	self
		emit: $(;
		emitAll: self contextPositionVariable;
		emitAll: ' ifNil:[1])'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/23/2016 08:46'!
handlePredicateAttribute: aName equalsStringLiteral: aStringLiteral
	self
		emitStartAttributePredicate: aName;
		emit: $=;
		emitQuotedString: aStringLiteral;
		emitEndAttributePredicate! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/23/2016 08:46'!
handlePredicateAttribute: aName notEqualsStringLiteral: aStringLiteral
	self
		emitStartAttributePredicate: aName;
		emitAll: '~=';
		emitQuotedString: aStringLiteral;
		emitEndAttributePredicate! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 08:51'!
handleStartAbsoluteLocationPath
	self
		emitAll: self contextNodeVariable;
		emitAll: ' asXPathLocationPathRoot documentRoot'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:23'!
handleStartAdditiveExpression
	self
		emit: $(;
		pushOperator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:23'!
handleStartAndExpression
	self
		emit: $(;
		pushOperator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:23'!
handleStartEqualityExpression
	self
		emit: $(;
		pushOperator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 09:02'!
handleStartFilterExpression
	self emit: $(! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 08:52'!
handleStartFilterExpressionLocationPath
	self emitAll: ' asXPathLocationPathRoot'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 10/5/2016 17:57'!
handleStartFunctionCall: aFunctionName
	self
		emitAll: '((';
		emitAll: self contextVariable;
		emitAll: ' resolveFunctionReference: ''';
		emitAll: aFunctionName;
		emitAll: ''' contextNode: ';
		emitAll: self contextNodeVariable;
		emitAll: ' arguments: {'.! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:23'!
handleStartMultiplicativeExpression
	self
		emit: $(;
		pushOperator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:23'!
handleStartOrExpression
	self
		emit: $(;
		pushOperator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling' stamp: 'monty 9/22/2016 16:38'!
handleStartParsing
	"must use #writeStream instead of 'WriteStream on:' to get a 0-based
	stream on Gemstone"
	outputStream := (String new: 128) writeStream.
	variableStack := OrderedCollection new.
	operatorStack := OrderedCollection new.

	self emitStartContextBlock.! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 09:02'!
handleStartPathExpression
	self emit: $(! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:25'!
handleStartPredicate
	self emitStartPredicateBlock! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/23/2016 08:45'!
handleStartPredicates
	self emitAll: ' asXPathFilterable filterWithAll: {'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:23'!
handleStartRelationalExpression
	self
		emit: $(;
		pushOperator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 08:52'!
handleStartRelativeLocationPath
	self
		emitAll: self contextNodeVariable;
		emitAll: ' asXPathLocationPathRoot'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:23'!
handleStartUnaryExpression
	self
		emit: $(;
		pushOperator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:23'!
handleStartUnionExpression
	self
		emit: $(;
		pushOperator! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/20/2015 11:15'!
handleStringLiteral: aString
	self emitQuotedString: aString! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:19'!
handleSubtraction
	self
		emitNumberConversion;
		currentOperator: $-! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:52'!
handleTestForAnyNodeType
	self emitAll: '[:n|true]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:52'!
handleTestForAttributeWithAnyName
	self emitAll: '[:n|n isAttribute]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:53'!
handleTestForAttributeWithLocalName: aLocalName
	self
		emitAll: '[:n|n isAttribute and:[n localName=''';
		emitAll: aLocalName;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:55'!
handleTestForAttributeWithName: aName
	self
		emitAll: '[:n|n isAttribute and:[n name=''';
		emitAll: aName;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:55'!
handleTestForAttributeWithNamespaceURI: aURI
	self
		emitAll: '[:n|n isAttribute and:[n namespaceURI=''';
		emitAll: aURI;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:55'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	self
		emitAll: '[:n|n isAttribute and:[n localName=''';
		emitAll: aLocalName;
		emitAll: '''and:[n namespaceURI=''';
		emitAll: aURI;
		emitAll: ''']]]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/25/2016 09:20'!
handleTestForAttributeWithPrefix: aPrefix
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' testForAttributeWithPrefix:''';
		emitAll: aPrefix;
		emitAll: ''')'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/25/2016 09:20'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' testForAttributeWithPrefix:''';
		emitAll: aPrefix;
		emitAll: '''localName:''';
		emitAll: aLocalName;
		emitAll: ''')'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:56'!
handleTestForCommentType
	self emitAll: '[:n|n isComment]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:56'!
handleTestForElementWithAnyName
	self emitAll: '[:n|n isElement]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:56'!
handleTestForElementWithLocalName: aLocalName
	self
		emitAll: '[:n|n isElement and:[n localName=''';
		emitAll: aLocalName;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:56'!
handleTestForElementWithName: aName
	self
		emitAll: '[:n|n isElement and:[n name=''';
		emitAll: aName;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:56'!
handleTestForElementWithNamespaceURI: aURI
	self
		emitAll: '[:n|n isElement and:[n namespaceURI=''';
		emitAll: aURI;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:57'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	self
		emitAll: '[:n|n isElement and:[n localName=''';
		emitAll: aLocalName;
		emitAll: '''and:[n namespaceURI=''';
		emitAll: aURI;
		emitAll: ''']]]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/25/2016 09:20'!
handleTestForElementWithPrefix: aPrefix
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' testForElementWithPrefix:''';
		emitAll: aPrefix;
		emitAll: ''')'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/25/2016 09:20'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' testForElementWithPrefix:''';
		emitAll: aPrefix;
		emitAll: '''localName:''';
		emitAll: aLocalName;
		emitAll: ''')'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:57'!
handleTestForNamespaceWithAnyName
	self emitAll: '[:n|n isNamespace]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:57'!
handleTestForNamespaceWithLocalName: aLocalName
	self
		emitAll: '[:n|n isNamespace and:[n localName=''';
		emitAll: aLocalName;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:57'!
handleTestForNamespaceWithName: aName
	self
		emitAll: '[:n|n isNamespace and:[n name=''';
		emitAll: aName;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:55'!
handleTestForNamespaceWithNamespaceURI: aURI
	self
		emitAll: '[:n|n isNamespace and:[n namespaceURI=''';
		emitAll: aURI;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:55'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName
	self
		emitAll: '[:n|n isNamespace and:[n localName=''';
		emitAll: aLocalName;
		emitAll: '''and:[n namespaceURI=''';
		emitAll: aURI;
		emitAll: ''']]]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/25/2016 09:20'!
handleTestForNamespaceWithPrefix: aPrefix
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' testForNamespaceWithPrefix:''';
		emitAll: aPrefix;
		emitAll: ''')'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/25/2016 09:20'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' testForNamespaceWithPrefix:''';
		emitAll: aPrefix;
		emitAll: '''localName:''';
		emitAll: aLocalName;
		emitAll: ''')'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:54'!
handleTestForPIWithAnyName
	self emitAll: '[:n|n isPI]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:54'!
handleTestForPIWithName: aName
	self
		emitAll: '[:n|n isPI and:[n target=''';
		emitAll: aName;
		emitAll: ''']]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/23/2016 08:54'!
handleTestForTextType
	self emitAll: '[:n|n isStringNode]'! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/23/2016 09:18'!
handleUnion
	self
		emitUnionableConversion;
		currentOperator: $|! !

!XPathCompilingExpressionParserHandler methodsFor: 'handling' stamp: 'monty 2/26/2016 04:52'!
handleVariableReference: aName
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' resolveVariableReference: ''';
		emitAll: aName;
		emitAll: ''')'! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/22/2016 09:47'!
hasCurrentOperator
	^ self currentOperator notNil! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 07:09'!
popOperator
	operatorStack removeLast! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 06:44'!
popVariables
	variableStack removeLast! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 07:09'!
pushOperator
	operatorStack addLast: nil! !

!XPathCompilingExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/23/2016 06:44'!
pushVariables
	| indexString |

	indexString := (variableStack size + 1) printString.
	variableStack addLast:
		(Array
			with: (indexString copyWithFirst: $n) "node variable"
			with: (indexString copyWithFirst: $p) "position variable"
			with: (indexString copyWithFirst: $s)). "size variable"! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleAddition! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 11:11'!
handleAnd! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleAxis: anAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleDivision! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndAdditiveExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndAndExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndEqualityExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleEndFilterExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleEndFunctionArgument! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleEndFunctionCall! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndMultiplicativeExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndOrExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleEndPathExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/22/2016 04:27'!
handleEndPredicate! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/23/2016 07:05'!
handleEndPredicates! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndRelationalExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleEndStep! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndUnaryExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndUnionExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEquals! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleGreaterThan! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleGreaterThanOrEqualTo! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/22/2016 04:27'!
handleIntegerPredicate: anIntegerString! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleLastFunctionCall! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleLessThan! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleLessThanOrEqualTo! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleModulus! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleMultiplication! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleNegation! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleNotEquals! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:27'!
handleNumberLiteral: anIntegerOrFloatString! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 11:11'!
handleOr! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handlePositionFunctionCall! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/22/2016 04:27'!
handlePredicateAttribute: aName equalsStringLiteral: aStringLiteral! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/22/2016 04:27'!
handlePredicateAttribute: aName notEqualsStringLiteral: aStringLiteral! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartAbsoluteLocationPath! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartAdditiveExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartAndExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartEqualityExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartFilterExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartFilterExpressionLocationPath! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleStartFunctionArgument! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleStartFunctionCall: aFunctionName! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartMultiplicativeExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartOrExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartPathExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/22/2016 04:27'!
handleStartPredicate! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/23/2016 07:05'!
handleStartPredicates! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartRelationalExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartRelativeLocationPath! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartStep! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartUnaryExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartUnionExpression! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:27'!
handleStringLiteral: aString! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleSubtraction! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForAnyNodeType! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForAttributeWithAnyName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForAttributeWithLocalName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForAttributeWithName: aName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForAttributeWithNamespaceURI: aURI! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForAttributeWithPrefix: aPrefix! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForCommentType! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForElementWithAnyName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForElementWithLocalName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForElementWithName: aName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForElementWithNamespaceURI: aURI! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForElementWithPrefix: aPrefix! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForNamespaceWithAnyName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForNamespaceWithLocalName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForNamespaceWithName: aName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForNamespaceWithNamespaceURI: aURI! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForNamespaceWithPrefix: aPrefix! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForPIWithAnyName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForPIWithName: aName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/22/2016 04:27'!
handleTestForTextType! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleUnion! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:27'!
handleVariableReference: aName! !

XPathParserHandler subclass: #XPathFunctionPrototypeParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathFunctionPrototypeParserHandler commentStamp: 'monty 2/22/2016 04:52' prior: 0!
An abstract class for function prototype parser handlers.!

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:50'!
handleArgument: anArgument! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:51'!
handleFunctionName: aName! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:51'!
handleOptionalArgument: anArgument! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:51'!
handleReturnType: aReturnType! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:52'!
handleUnboundedArgument: anArgument! !

XPathFunctionPrototypeParserHandler subclass: #XPathTypedFunctionPrototypeParserHandler
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathTypedFunctionPrototypeParserHandler commentStamp: 'monty 9/28/2016 23:26' prior: 0!
A handler class for function prototype parsers that returns XPathFunctionPrototypes with the function name, return type, and number and types of arguments from the prototype source.!

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 9/23/2016 13:22'!
addArgumentTypeFor: aTypeName
	argumentTypes addLast: (self classForTypeName: aTypeName)! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 9/23/2016 13:26'!
booleanClass
	^ Boolean! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:26'!
classForTypeName: aTypeName
	^ self
		classForTypeName: aTypeName
		ifAbsent: [self errorUnrecognizedTypeName: aTypeName]! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:26'!
classForTypeName: aTypeName ifAbsent: aBlock
	aTypeName = 'object'
		ifTrue: [^ self objectClass].
	aTypeName = 'boolean'
		ifTrue: [^ self booleanClass].
	aTypeName = 'string'
		ifTrue: [^ self stringClass].
	aTypeName = 'number'
		ifTrue: [^ self numberClass].
	aTypeName = 'node-set'
		ifTrue: [^ self nodeSetClass].
	^ aBlock value.! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 9/23/2016 13:27'!
errorUnrecognizedTypeName: aTypeName
	XPathTypeException
		formatSignal: 'Unrecognized type name "{1}"'
		with: aTypeName! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleArgument: anArgument
	minArguments := minArguments + 1.
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 9/23/2016 13:21'!
handleEndParsing
	self parsingResult:
		(XPathFunctionPrototype
			returnType: returnType
			functionName: functionName
			minArguments: minArguments
			maxArguments: maxArguments
			argumentTypes: argumentTypes)! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:17'!
handleFunctionName: aName
	functionName := aName! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleOptionalArgument: anArgument
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 9/23/2016 13:33'!
handleReturnType: aReturnType
	returnType := self classForTypeName: aReturnType! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 9/28/2016 02:24'!
handleStartParsing
	minArguments := 0.
	maxArguments := 0.
	argumentTypes := OrderedCollection new.! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:32'!
handleUnboundedArgument: anArgument
	maxArguments := nil.
	self addArgumentTypeFor: anArgument.! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 9/23/2016 13:26'!
nodeSetClass
	^ XPathNodeSet! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 9/23/2016 13:26'!
numberClass
	^ Number! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 9/23/2016 13:26'!
objectClass
	^ Object! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 9/23/2016 13:26'!
stringClass
	^ String! !

XPathParserHandler subclass: #XPathNodeTestParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserHandler commentStamp: 'monty 11/20/2015 22:08' prior: 0!
An abstract class for node test parser handlers. Parsing is controlled by XPathNodeTestParserContext classes.!

XPathNodeTestParserHandler subclass: #XPathCompilingNodeTestParserHandler
	instanceVariableNames: 'currentAxis expressionParserHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathCompilingNodeTestParserHandler commentStamp: 'monty 2/10/2015 20:39' prior: 0!
A handler used by the expression parser for parsing node tests that are part of location path steps.!

!XPathCompilingNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 1/13/2015 11:43'!
currentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	^ self new
		setCurrentAxis: anAxis
		expressionParserHandler: anExpressionParserHandler! !

!XPathCompilingNodeTestParserHandler methodsFor: 'accessing' stamp: 'monty 4/11/2015 03:55'!
defaultNodeTestParserContextClass
	^ currentAxis defaultNodeTestParserContextClass! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/21/2015 18:30'!
handleEmptyTest
	self parsingResult: false! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/13/2015 12:42'!
handleStartParsing
	self parsingResult: false! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType
	self startNodeTest.
	expressionParserHandler handleTestForAnyNodeType.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithAnyName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:00'!
handleTestForAttributeWithLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithLocalName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:51'!
handleTestForAttributeWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithName: aName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForAttributeWithNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithNamespaceURI: aURI.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForAttributeWithNamespaceURI: aURI
		localName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:52'!
handleTestForAttributeWithPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithPrefix: aPrefix.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:50'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForAttributeWithPrefix: aPrefix
		localName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType
	self startNodeTest.
	expressionParserHandler handleTestForCommentType.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithAnyName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:42'!
handleTestForElementWithLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithLocalName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:42'!
handleTestForElementWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithName: aName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForElementWithNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleTestForElementWithNamespaceURI: aURI.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForElementWithNamespaceURI: aURI
		localName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:43'!
handleTestForElementWithPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForElementWithPrefix: aPrefix.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:43'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForElementWithPrefix: aPrefix
		localName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:42'!
handleTestForNamespaceWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithAnyName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:44'!
handleTestForNamespaceWithLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithLocalName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:46'!
handleTestForNamespaceWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithName: aName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:36'!
handleTestForNamespaceWithNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithNamespaceURI: aURI.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:52'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForNamespaceWithNamespaceURI: aURI
		localName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:48'!
handleTestForNamespaceWithPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithPrefix: aPrefix.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:50'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForNamespaceWithPrefix: aPrefix
		localName: aLocalName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:41'!
handleTestForPIWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForPIWithAnyName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForPIWithName: aName.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType
	self startNodeTest.
	expressionParserHandler handleTestForTextType.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ false! !

!XPathCompilingNodeTestParserHandler methodsFor: 'initialization' stamp: 'monty 1/13/2015 11:43'!
setCurrentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	currentAxis := anAxis.
	expressionParserHandler := anExpressionParserHandler.! !

!XPathCompilingNodeTestParserHandler methodsFor: 'private' stamp: 'monty 11/18/2015 22:16'!
startNodeTest
	self parsingResult: true.
	currentAxis isStartOfRelativeLocationPath
		ifTrue: [expressionParserHandler handleStartRelativeLocationPath].
	expressionParserHandler
		handleStartStep;
		handleAxis: currentAxis.
	currentAxis beDefaultImplicitAxis.! !

!XPathNodeTestParserHandler methodsFor: 'accessing' stamp: 'monty 4/11/2015 03:55'!
defaultNodeTestParserContextClass
	self subclassResponsibility! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:51'!
handleEmptyTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:59'!
handleTestForAttributeWithLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:19'!
handleTestForAttributeWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForAttributeWithNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:19'!
handleTestForAttributeWithPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForElementWithNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:42'!
handleTestForNamespaceWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:44'!
handleTestForNamespaceWithLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:46'!
handleTestForNamespaceWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForNamespaceWithNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:52'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:48'!
handleTestForNamespaceWithPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:49'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:41'!
handleTestForPIWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType! !

XPathNodeTestParserHandler subclass: #XPathStringNodeTestParserHandler
	instanceVariableNames: 'defaultNodeTestParserContextClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathStringNodeTestParserHandler commentStamp: 'monty 11/20/2015 20:32' prior: 0!
A handler for node tests that occur in string arguments to the axis selectors defined in the "enumerating - axis" category of XMLNode and subclasses. It converts them to node test blocks.!

!XPathStringNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 11/21/2015 00:31'!
withAttributePrincipalNodeType
	^ self new defaultNodeTestParserContextClass: XPathNodeTestParserAttributeContext! !

!XPathStringNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 11/21/2015 00:31'!
withElementPrincipalNodeType
	^ self new defaultNodeTestParserContextClass: XPathNodeTestParserElementContext! !

!XPathStringNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 11/21/2015 00:31'!
withNamespacePrincipalNodeType
	^ self new defaultNodeTestParserContextClass: XPathNodeTestParserNamespaceContext! !

!XPathStringNodeTestParserHandler methodsFor: 'accessing' stamp: 'monty 4/11/2015 03:56'!
defaultNodeTestParserContextClass
	^ defaultNodeTestParserContextClass! !

!XPathStringNodeTestParserHandler methodsFor: 'accessing' stamp: 'monty 4/11/2015 03:56'!
defaultNodeTestParserContextClass: aClass
	defaultNodeTestParserContextClass := aClass! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/17/2015 08:16'!
handleEmptyTest
	XPathSyntaxException signal: 'String arguments to axis selectors must contain node tests'! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType
	self parsingResult: [:node | true]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName
	self parsingResult: [:node | node isAttribute]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:00'!
handleTestForAttributeWithLocalName: aLocalName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:20'!
handleTestForAttributeWithName: aName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:35'!
handleTestForAttributeWithNamespaceURI: aURI
	self parsingResult:
		[:node |
			node isAttribute
				and: [node namespaceURI = aURI]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:18'!
handleTestForAttributeWithPrefix: aPrefix
	self parsingResult:
		[:node |
			node isAttribute
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/1/2016 00:57'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithXMLPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isAttribute
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType
	self parsingResult: [:node | node isComment]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName
	self parsingResult: [:node | node isElement]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithLocalName: aLocalName
	self parsingResult:
		[:node |
			node isElement
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithName: aName
	self parsingResult:
		[:node |
			node isElement
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:35'!
handleTestForElementWithNamespaceURI: aURI
	self parsingResult:
		[:node |
			node isElement
				and: [node namespaceURI = aURI]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isElement
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix
	self parsingResult:
		[:node |
			node isElement
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/1/2016 00:57'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithXMLPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isElement
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:42'!
handleTestForNamespaceWithAnyName
	self parsingResult: [:node | node isNamespace]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:44'!
handleTestForNamespaceWithLocalName: aLocalName
	self parsingResult:
		[:node |
			node isNamespace
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:46'!
handleTestForNamespaceWithName: aName
	self parsingResult:
		[:node |
			node isNamespace
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:35'!
handleTestForNamespaceWithNamespaceURI: aURI
	self parsingResult:
		[:node |
			node isNamespace
				and: [node namespaceURI = aURI]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:52'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isNamespace
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:48'!
handleTestForNamespaceWithPrefix: aPrefix
	self parsingResult:
		[:node |
			node isNamespace
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/1/2016 00:57'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithXMLPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isNamespace
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:41'!
handleTestForPIWithAnyName
	self parsingResult: [:node | node isPI]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName
	self parsingResult:
		[:node |
			node isPI
				and: [node target = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType
	self parsingResult: [:node | node isStringNode]! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleEndParsing! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleStartParsing! !

!XPathParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ true! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 1/10/2015 06:10'!
parsingResult
	^ parsingResult! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 3/14/2015 14:00'!
parsingResult: aParsingResult
	"set value to be returned by #parse"

	parsingResult := aParsingResult! !

Object subclass: #XPathPushedBackToken
	instanceVariableNames: 'value position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackToken commentStamp: 'monty 1/15/2015 11:06' prior: 0!
This is a class for storing pushed-back tokens so they can be quickly read again.!

XPathPushedBackToken subclass: #XPathPushedBackNCNameToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackNCNameToken commentStamp: 'monty 1/10/2015 01:22' prior: 0!
A pushed-back non-qualified name token, to be read by nextNCName.!

!XPathPushedBackNCNameToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:21'!
isNCNameToken
	^ true! !

!XPathPushedBackToken class methodsFor: 'instance creation' stamp: 'monty 3/25/2016 21:03'!
value: aValue position: aPosition
	^ self new
		setValue: aValue
		position: aPosition! !

!XPathPushedBackToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:19'!
isNCNameToken
	^ false! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 1/9/2015 08:18'!
position
	^ position! !

!XPathPushedBackToken methodsFor: 'initialization' stamp: 'monty 3/25/2016 21:03'!
setValue: aValue position: aPosition
	value := aValue.
	position := aPosition.! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 3/25/2016 21:04'!
value
	^ value! !

Object subclass: #XPathReadStreamAdapter
	instanceVariableNames: 'stream pushedBackToken writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathReadStreamAdapter commentStamp: 'monty 3/27/2015 21:44' prior: 0!
This class is an adapter for positionable read streams that wraps them to be safe to send messages like next and peek when atEnd and supports efficient push back of token objects to minimize backtracking by parsers.!

!XPathReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 4/7/2015 09:12'!
on: aPositionableStream
	^ self new on: aPositionableStream! !

!XPathReadStreamAdapter methodsFor: 'converting' stamp: 'monty 1/14/2015 03:19'!
asXPathReadStreamAdapter
	^ self! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/8/2015 02:50'!
atEnd
	^ stream atEnd! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/10/2015 01:20'!
isStream
	^ true! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:11'!
next
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream next]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 12/6/2016 09:40'!
nextMatchAll: aString
	| oldPosition |

	(stream atEnd not
		and: [stream peek = (aString at: 1)])
		ifFalse: [^ false].

	oldPosition := stream position.
	stream next.
	2 to: aString size do: [:i |
		(stream atEnd not
			and: [stream next = (aString at: i)])
			ifFalse: [
				stream position: oldPosition.
				^ false]].
	^ true.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 3/25/2016 21:45'!
nextNCName
	"returns the next non-qualified name or nil"

	(self peekPushedBackToken notNil
		and: [self peekPushedBackToken isNCNameToken])
		ifTrue: [^ self nextPushedBackToken value].

	writeStream reset.
	self peek isXMLNCNameStartChar
		ifFalse: [^ nil].
	writeStream nextPut: self next.

	[self peek isXMLNCNameChar]
		whileTrue: [writeStream nextPut: self next].
	^ writeStream contents.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:57'!
nextName
	"returns the next qualified or non-qualified name or nil"

	| oldPosition ncNameOrPrefix |

	oldPosition := self position.
	(ncNameOrPrefix := self nextNCName)
		ifNil: [^ nil].
	(self peekFor: $:)
		ifFalse: [
			"just a local name"
			^ ncNameOrPrefix].
	self nextNCName
		ifNil: [
			"an NCName followed by : must have a local name after"
			self position: oldPosition.
			^ nil]
		ifNotNil: [:localName |
			"a full qualified name"
			^ localName qualifyWithXMLPrefix: ncNameOrPrefix].! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 3/25/2016 21:44'!
nextPushedBackToken
	self peekPushedBackToken
		ifNil: [^ nil]
		ifNotNil: [:token |
			self position: self position + token value size.
			^ token]! !

!XPathReadStreamAdapter methodsFor: 'initialization' stamp: 'monty 9/22/2016 16:37'!
on: aStream
	stream := aStream.
	"must use #writeStream instead of 'WriteStream on:' to get a 0-based
	stream on Gemstone"
	writeStream := (String new: 32) writeStream.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:11'!
peek
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream peek]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 12/6/2016 09:40'!
peekFor: aCharacter
	(stream atEnd not
		and: [stream peek = aCharacter])
		ifTrue: [
			stream next.
			^ true]
		ifFalse: [^ false]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 3/25/2016 21:42'!
peekPushedBackToken
	^ (pushedBackToken notNil
		and: [pushedBackToken position = self position])
		ifTrue: [^ pushedBackToken]
		ifFalse: [^ nil]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 02:50'!
position
	^ stream position! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 02:50'!
position: aPosition
	stream position: aPosition! !

!XPathReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 3/25/2016 21:42'!
pushBackNCName: anNCName position: aPosition
	self pushBackToken:
		(XPathPushedBackNCNameToken
			value: anNCName
			position: aPosition)! !

!XPathReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 1/9/2015 11:33'!
pushBackToken: aPushedBackToken
	pushedBackToken := aPushedBackToken.
	self position: aPushedBackToken position.! !

!XPathReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 1/19/2015 13:51'!
skipBack
	"does not peek like #back"
	stream position: stream position - 1! !

!XPathReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 4/7/2015 09:13'!
skipSeparators
	stream xPathSkipSeparators! !

Object subclass: #XPathSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

XPathSortOrder class
	instanceVariableNames: 'instance'!

!XPathSortOrder commentStamp: 'monty 6/1/2015 19:28' prior: 0!
Abstract class for node sort orders to keep track of the order of nodes in a node set. Instances of subclasses are immutable and shared.!

XPathSortOrder class
	instanceVariableNames: 'instance'!

XPathSortOrder subclass: #XPathDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathDocumentSortOrder commentStamp: 'monty 2/10/2015 03:47' prior: 0!
A sort order for nodes in document order.!

!XPathDocumentSortOrder methodsFor: 'converting' stamp: 'monty 10/18/2015 04:18'!
asReversedSortOrder
	^ XPathReverseDocumentSortOrder new! !

!XPathDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 1/30/2015 17:12'!
documentOrderSort: aNodeSet
	"already in document order"! !

!XPathDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet first! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:32'!
on: aNodeSet attributeAxis: aStringOrBlockOrNodeTestWithFilters
	^ (super
		on: aNodeSet
		attributeAxis: aStringOrBlockOrNodeTestWithFilters) sortOrderFrom: aNodeSet! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:33'!
on: aNodeSet namespaceAxis: aStringOrBlockOrNodeTestWithFilters
	^ (super
		on: aNodeSet
		namespaceAxis: aStringOrBlockOrNodeTestWithFilters) sortOrderFrom: aNodeSet! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:33'!
on: aNodeSet parentAxis: aStringOrBlockOrNodeTestWithFilters
	"this is a document order axis according to the spec"
	^ (super
		on: aNodeSet
		parentAxis: aStringOrBlockOrNodeTestWithFilters) sortOrderFrom: aNodeSet! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:34'!
on: aNodeSet selfAxis: aStringOrBlockOrNodeTestWithFilters
	^ (super
		on: aNodeSet
		selfAxis: aStringOrBlockOrNodeTestWithFilters) sortOrderFrom: aNodeSet! !

XPathSortOrder subclass: #XPathReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathReverseDocumentSortOrder commentStamp: 'monty 3/31/2015 02:16' prior: 0!
A sort order for nodes in reverse document order.!

!XPathReverseDocumentSortOrder methodsFor: 'converting' stamp: 'monty 10/18/2015 04:19'!
asReversedSortOrder
	^ XPathDocumentSortOrder new! !

!XPathReverseDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 10/18/2015 04:17'!
documentOrderSort: aNodeSet
	aNodeSet reverseInPlace! !

!XPathReverseDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet last! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:36'!
on: aNodeSet attributeAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet last attributeAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			aNodeSet size - 1 to: 1 by: -1 do: [:i |
				((aNodeSet at: i) attributeAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			aNodeSet size - 1 to: 1 by: -1 do: [:i |
				(aNodeSet at: i)
					attributeAxisSelect: nodeTestBlock
					into: copy]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:36'!
on: aNodeSet namespaceAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet last namespaceAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			aNodeSet size - 1 to: 1 by: -1 do: [:i |
				((aNodeSet at: i) namespaceAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			aNodeSet size - 1 to: 1 by: -1 do: [:i |
				(aNodeSet at: i)
					namespaceAxisSelect: nodeTestBlock
					into: copy]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:33'!
on: aNodeSet parentAxis: aStringOrBlockOrNodeTestWithFilters
	| copy nodeTestBlock |

	copy := aNodeSet copyEmpty.
	aNodeSet isEmpty
		ifTrue: [^ copy].

	nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
	aNodeSet size to: 1 by: -1 do: [:i |
		(aNodeSet at: i)
			parentAxisSelect: nodeTestBlock
			ifNotPresentInto: copy].
	^ copy "parent is a document order axis according to the spec"
		sortOrder: XPathDocumentSortOrder new;
		filterEachInSeparateContextWithAll:
			aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters.! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:34'!
on: aNodeSet selfAxis: aStringOrBlockOrNodeTestWithFilters
	| copy nodeTestBlock |

	copy := aNodeSet copyEmpty.
	aNodeSet isEmpty
		ifTrue: [^ copy].

	nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
	aNodeSet size to: 1 by: -1 do: [:i |
		(aNodeSet at: i)
			selfAxisSelect: nodeTestBlock
			into: copy].
	^ copy
		sortOrder: XPathDocumentSortOrder new;
		filterEachInSeparateContextWithAll:
			aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters.! !

!XPathSortOrder class methodsFor: 'accessing' stamp: 'monty 10/9/2016 04:59'!
instance
	^ instance
		ifNil: [instance := self basicNew initialize]! !

!XPathSortOrder class methodsFor: 'instance creation' stamp: 'monty 10/9/2016 04:59'!
new
	"these classes are immutable and shared, so they are only initialized once"
	^ self instance! !

!XPathSortOrder methodsFor: 'converting' stamp: 'monty 10/18/2015 04:18'!
asReversedSortOrder
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'sorting' stamp: 'monty 1/26/2015 18:43'!
documentOrderSort: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrderFrom: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:34'!
on: aNodeSet ancestorAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first ancestorAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) ancestorAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllIfNotPresentTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					ancestorAxisSelect: nodeTestBlock
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:35'!
on: aNodeSet ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllIfNotPresentTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					ancestorOrSelfAxisSelect: nodeTestBlock
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:35'!
on: aNodeSet attributeAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first attributeAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) attributeAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					attributeAxisSelect: nodeTestBlock
					into: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:39'!
on: aNodeSet childAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first childAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) childAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					childAxisSelect: nodeTestBlock
					into: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:39'!
on: aNodeSet descendantAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first descendantAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) descendantAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllIfNotPresentTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					descendantAxisSelect: nodeTestBlock
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:39'!
on: aNodeSet descendantOrSelfAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first descendantOrSelfAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) descendantOrSelfAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllIfNotPresentTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					descendantOrSelfAxisSelect: nodeTestBlock
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:39'!
on: aNodeSet followingAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first followingAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) followingAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllIfNotPresentTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					followingAxisSelect: nodeTestBlock
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:40'!
on: aNodeSet followingSiblingAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first followingSiblingAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) followingSiblingAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllIfNotPresentTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					followingSiblingAxisSelect: nodeTestBlock
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:40'!
on: aNodeSet namespaceAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first namespaceAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) namespaceAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					namespaceAxisSelect: nodeTestBlock
					into: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:33'!
on: aNodeSet parentAxis: aStringOrBlockOrNodeTestWithFilters
	| copy nodeTestBlock |

	copy := aNodeSet copyEmpty.
	aNodeSet isEmpty
		ifTrue: [^ copy].

	nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
	1 to: aNodeSet size do: [:i |
		(aNodeSet at: i)
			parentAxisSelect: nodeTestBlock
			ifNotPresentInto: copy].
	^ copy filterEachInSeparateContextWithAll:
		aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:41'!
on: aNodeSet precedingAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first precedingAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) precedingAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllIfNotPresentTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					precedingAxisSelect: nodeTestBlock
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:41'!
on: aNodeSet precedingSiblingAxis: aStringOrBlockOrNodeTestWithFilters
	| copy |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].

	copy := aNodeSet first precedingSiblingAxis: aStringOrBlockOrNodeTestWithFilters.
	aStringOrBlockOrNodeTestWithFilters hasXPathNodeSetFilters
		ifTrue: [
			2 to: aNodeSet size do: [:i |
				((aNodeSet at: i) precedingSiblingAxis: aStringOrBlockOrNodeTestWithFilters)
					addAllIfNotPresentTo: copy]]
		ifFalse: [| nodeTestBlock |
			nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
			2 to: aNodeSet size do: [:i |
				(aNodeSet at: i)
					precedingSiblingAxisSelect: nodeTestBlock
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/21/2016 12:34'!
on: aNodeSet selfAxis: aStringOrBlockOrNodeTestWithFilters
	| copy nodeTestBlock |

	copy := aNodeSet copyEmpty.
	aNodeSet isEmpty
		ifTrue: [^ copy].

	nodeTestBlock := aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock.
	1 to: aNodeSet size do: [:i |
		(aNodeSet at: i)
			selfAxisSelect: nodeTestBlock
			into: copy].
	^ copy filterEachInSeparateContextWithAll:
		aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters.! !

XPathSortOrder subclass: #XPathUnknownSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathUnknownSortOrder commentStamp: 'monty 2/10/2015 03:49' prior: 0!
A sort order for unsorted nodes or nodes in an unknown sort order.!

!XPathUnknownSortOrder methodsFor: 'converting' stamp: 'monty 10/18/2015 04:19'!
asReversedSortOrder
	^ self! !

!XPathUnknownSortOrder methodsFor: 'sorting' stamp: 'monty 6/9/2015 01:58'!
documentOrderSort: aNodeSet
	(XPathNodeSetSorter on: aNodeSet) sort! !

!XPathUnknownSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet sorted first! !

!XMLComment methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self string! !

XMLException subclass: #XPathException
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathException commentStamp: 'monty 12/20/2014 19:26' prior: 0!
A base class for XPath exceptions.!

XPathException subclass: #XPathArgumentNumberException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathArgumentNumberException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for function calls with the wrong number of arguments.!

XPathException subclass: #XPathDOMException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathDOMException commentStamp: 'monty 6/11/2015 00:17' prior: 0!
Invoked when node sets are manipulated incorrectly.!

!XPathException methodsFor: 'testing' stamp: 'monty 4/12/2015 07:26'!
hasPosition
	^ position notNil! !

!XPathException methodsFor: 'accessing' stamp: 'monty 4/11/2015 05:37'!
position
	^ position! !

!XPathException methodsFor: 'accessing' stamp: 'monty 11/23/2016 19:57'!
position: aPosition
	position := aPosition.
	self
		messageTextAppend: aPosition
		withDescription: 'at pos.'.! !

XPathException subclass: #XPathSyntaxException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathSyntaxException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for syntax errors in XPath expressions.!

XPathException subclass: #XPathTypeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathTypeException commentStamp: 'monty 1/18/2015 13:55' prior: 0!
Invoked for type conversion errors.!

XPathException subclass: #XPathUndeclaredFunctionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredFunctionException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared functions.!

XPathException subclass: #XPathUndeclaredPrefixException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredPrefixException commentStamp: 'monty 6/15/2015 00:34' prior: 0!
Invoked for undeclared namespace prefixes used in name tests (only when one or more namespaces are set in the context).!

XPathException subclass: #XPathUndeclaredVariableException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredVariableException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared variables.!

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:20'!
% aStringOrBlockOrNodeTestWithFilters
	^ self parentAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:21'!
%% aStringOrBlockOrNodeTestWithFilters
	^ self ancestorAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:22'!
%%~ aStringOrBlockOrNodeTestWithFilters
	^ self ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:22'!
/ aStringOrBlockOrNodeTestWithFilters
	^ self childAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:23'!
// aStringOrBlockOrNodeTestWithFilters
	^ self descendantAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:23'!
//~ aStringOrBlockOrNodeTestWithFilters
	^ self descendantOrSelfAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:24'!
<< aStringOrBlockOrNodeTestWithFilters
	^ self precedingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:25'!
<<< aStringOrBlockOrNodeTestWithFilters
	^ self precedingSiblingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:26'!
>> aStringOrBlockOrNodeTestWithFilters
	^ self followingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:27'!
>>> aStringOrBlockOrNodeTestWithFilters
	^ self followingSiblingAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:25'!
@ aStringOrBlockOrNodeTestWithFilters
	^ self attributeAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:26'!
@@ aStringOrBlockOrNodeTestWithFilters
	^ self namespaceAxis: aStringOrBlockOrNodeTestWithFilters! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 1/16/2015 14:18'!
allNodesReverseDo: aBlock
	aBlock value: self! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:21'!
ancestorAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		ancestorAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathReverseDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:18'!
ancestorAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	self ancestorNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:49'!
ancestorAxisSelect: aNodeTestBlock into: aNodeSet
	self ancestorNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:22'!
ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		ancestorOrSelfAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathReverseDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:43'!
ancestorOrSelfAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	((aNodeSet includes: self) not
		and: [aNodeTestBlock value: self])
		ifTrue: [aNodeSet addLast: self].
	self ancestorNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:49'!
ancestorOrSelfAxisSelect: aNodeTestBlock into: aNodeSet
	(aNodeTestBlock value: self)
		ifTrue: [aNodeSet addLast: self].
	self ancestorNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:40'!
asXPathBoolean
	XPathTypeException signal: 'Cannot convert nodes to booleans'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:52'!
asXPathComparable
	XPathTypeException signal: 'Cannot compare nodes'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 11:18'!
asXPathFilterable
	XPathTypeException signal: 'Cannot filter nodes'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 10/29/2015 14:55'!
asXPathLocationPathRoot
	^ self! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:45'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert nodes to node sets'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:41'!
asXPathNumber
	XPathTypeException signal: 'Cannot convert nodes to numbers'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:44'!
asXPathString
	XPathTypeException signal: 'Cannot convert nodes to strings'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:20'!
asXPathUnionable
	XPathTypeException signal: 'Cannot union nodes'! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:25'!
attributeAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		attributeAxisSelect:
			aStringOrBlockOrNodeTestWithFilters asXPathAttributeNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 04:24'!
attributeAxisSelect: anAttributeNodeTestBlock into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:23'!
childAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		childAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:50'!
childAxisSelect: aNodeTestBlock into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:23'!
descendantAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		descendantAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:30'!
descendantAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:50'!
descendantAxisSelect: aNodeTestBlock into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:24'!
descendantOrSelfAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		descendantOrSelfAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:34'!
descendantOrSelfAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	((aNodeSet includes: self) not
		and: [aNodeTestBlock value: self])
		ifTrue: [aNodeSet addLast: self].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:35'!
descendantOrSelfAxisSelect: aNodeTestBlock into: aNodeSet
	(aNodeTestBlock value: self)
		ifTrue: [aNodeSet addLast: self].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:26'!
followingAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		followingAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:39'!
followingAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	self followingNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:50'!
followingAxisSelect: aNodeTestBlock into: aNodeSet
	self followingNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:42'!
followingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [each allNodesDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:27'!
followingSiblingAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		followingSiblingAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:40'!
followingSiblingAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	self followingSiblingNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:50'!
followingSiblingAxisSelect: aNodeTestBlock into: aNodeSet
	self followingSiblingNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:42'!
followingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:38'!
hasExpandedName
	^ false! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ false! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:26'!
namespaceAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		namespaceAxisSelect:
			aStringOrBlockOrNodeTestWithFilters asXPathNamespaceNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 04:24'!
namespaceAxisSelect: aNamespaceNodeTestBlock into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 6/30/2015 05:10'!
nodeSetClass
	^ XPathNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:20'!
parentAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		parentAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			"this is a document order axis according to spec"
			sortOrder: XPathDocumentSortOrder new;
			filterEachInSeparateContextWithAll:
				aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/11/2015 01:44'!
parentAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	(self hasParent
		and: [(aNodeSet includes: self parent) not
			and: [aNodeTestBlock value: self parent]])
		ifTrue: [aNodeSet addLast: self parent].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:51'!
parentAxisSelect: aNodeTestBlock into: aNodeSet
	(self hasParent
		and: [aNodeTestBlock value: self parent])
		ifTrue: [aNodeSet addLast: self parent].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:24'!
precedingAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		precedingAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathReverseDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 23:58'!
precedingAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	self precedingNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:51'!
precedingAxisSelect: aNodeTestBlock into: aNodeSet
	self precedingNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:43'!
precedingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [each allNodesReverseDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:25'!
precedingSiblingAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		precedingSiblingAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathReverseDocumentSortOrder new;
			filterWithAll: aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/11/2015 01:52'!
precedingSiblingAxisSelect: aNodeTestBlock ifNotPresentInto: aNodeSet
	self precedingSiblingNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:51'!
precedingSiblingAxisSelect: aNodeTestBlock into: aNodeSet
	self precedingSiblingNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:43'!
precedingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:25'!
selfAxis: aStringOrBlockOrNodeTestWithFilters
	^ (self
		selfAxisSelect: aStringOrBlockOrNodeTestWithFilters asXPathNodeTestBlock
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new;
			filterEachInSeparateContextWithAll:
				aStringOrBlockOrNodeTestWithFilters asXPathNodeSetFilters! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:51'!
selfAxisSelect: aNodeTestBlock into: aNodeSet
	(aNodeTestBlock value: self)
		ifTrue: [aNodeSet addLast: self].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	"returns XPath node string-value"
	 ^ ''! !

!XMLNode methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/12/2015 20:28'!
xPath: anXPathOrXPathString
	^ anXPathOrXPathString asXPath in: self! !

!XMLNode methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/12/2015 20:40'!
xPath: anXPathOrXPathString context: aContext
	^ anXPathOrXPathString asXPath
		in: self
		context: aContext! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/21/2016 12:25'!
~ aStringOrBlockOrNodeTestWithFilters
	^ self selfAxis: aStringOrBlockOrNodeTestWithFilters! !

XMLNode subclass: #XPathNamespaceNode
	instanceVariableNames: 'name uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNamespaceNode commentStamp: 'monty 9/22/2016 10:38' prior: 0!
This class models an element namespace prefix and URI mapping as a DOM node for compatibility with the XPath standard.!

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 3/22/2015 02:55'!
element: anElement name: aPrefix uri: aURI
	^ self new
		setElement: anElement
		name: aPrefix
		uri: aURI! !

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 3/10/2015 13:50'!
withXMLNamespaceOnElement: anElement
	^ self
		element: anElement
		name: 'xml'
		uri: XMLNamespaceScope xmlNamespaceURI! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 4/9/2015 02:08'!
= anObject
	"This is needed because namespace nodes aren't part of DOM trees
	and are created dynamically by XPath, so unless = is defined the union
	of two node sets could contain duplicate nodes for the same element
	namespace"

	self == anObject
		ifTrue: [^ true].

	self class == anObject class
		ifFalse: [^ false].

	"different elements don't share namespace nodes with the same name/uri
	according to the spec"
	^ self element = anObject element
		and: [self name = anObject name
			and: [self uri = anObject uri]].! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 12/23/2014 15:22'!
element
	^ parent! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:56'!
expandedName
	^ self localName expandWithXMLNamespaceURI: self namespaceURI! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 4/1/2016 17:44'!
hasNamespaceURI
	"spec says namespace nodes cannot be namespaced
	(the namespace part of the expanded name is null)"
	^ false! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 4/1/2016 17:47'!
hasPrefix
	"namespace names cannot be prefixed"
	^ false! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 3/10/2015 13:52'!
hash
	^ self name hash bitXor: self uri hash! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ true! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 13:52'!
localName
	^ self name! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 13:52'!
name
	^ name ifNil: [name := '']! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 14:14'!
namespaceURI
	"spec says namespace nodes cannot be namespaced
	(the namespace part of the expanded name is null)"
	^ ''! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 4/2/2016 02:40'!
prefix
	"namespace names cannot be prefixed"
	^ ''! !

!XPathNamespaceNode methodsFor: 'initialization' stamp: 'monty 3/22/2015 02:55'!
setElement: anElement name: aPrefix uri: aURI
	"reuse parent inst var, like in XMLAttribute"
	parent := anElement.
	name := aPrefix.
	uri := aURI.! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self uri! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 1/26/2015 20:32'!
uri
	^ uri ifNil: [uri := '']! !

!XPathNamespaceNode methodsFor: 'printing' stamp: 'monty 3/10/2015 13:53'!
writeXMLOn: aWriter
	aWriter
		writeName:
			(self name
				ifEmpty: ['xmlns']
				ifNotEmpty: ['xmlns:', self name])
		escapedContentValue: self uri! !

!Number class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathNumber! !

!Number class methodsFor: '*XPath-Core' stamp: 'monty 4/7/2015 09:15'!
xPathReadFrom: aStream
	| number |

	aStream xPathSkipSeparators.
	[number := Float readFrom: aStream]
		on: Error
		do: [:error | ^ Float nan].
	
	aStream xPathSkipSeparators.
	aStream atEnd
		ifFalse: [^ Float nan].

	^ number.! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 12/22/2014 18:16'!
asXPathBoolean
	^ (self isZero or: [self isNaN]) not! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:47'!
asXPathComparable
	^ XPathNumberComparable value: self! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 11:14'!
asXPathFilterable
	XPathTypeException signal: 'Cannot filter numbers'! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:42'!
asXPathLocationPathRoot
	XPathTypeException signal: 'Cannot use numbers as location path roots'! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:42'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert numbers to node sets'! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 12/23/2014 14:40'!
asXPathNumber
	^ self asFloat! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 3/6/2016 20:27'!
asXPathString
	self isNaN
		ifTrue: [^ 'NaN'].
	self isZero
		ifTrue: [^ '0'].
	self isInfinite
		ifTrue: [
			self < 0
				ifTrue: [^ '-Infinity']
				ifFalse: [^ 'Infinity']].

	"printOn:base: can correctly print BinaryFloats in decimal notation
	on GS (asString uses scientific), but printOn:base: can't be used with
	integers because it shows the 10r radix, and printOn:base:showRadix:
	can't be used either because floats don't understand it, so integers
	and floats are handled separately"
	self isInteger
		ifTrue: [^ self asString]
		ifFalse: [| writeStream |
			writeStream := (String new: 10) writeStream.
			"use asFloat to convert types like GS's DecimalFloat that don't
			have printOn:base:"
			self asFloat
				printOn: writeStream
				base: 10.
			^ writeStream contents].! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:19'!
asXPathUnionable
	XPathTypeException signal: 'Cannot union numbers'! !

!XMLElement methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:55'!
attributeAxisSelect: anAttributeNodeTestBlock into: aNodeSet
	self hasAttributes
		ifTrue: [
			self attributeNodesDo: [:each |
				(anAttributeNodeTestBlock value: each)
					ifTrue: [aNodeSet addLast: each]]].
	^ aNodeSet.! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 2/9/2015 22:23'!
hasNamespaceNodes
	"elements have at least one node for the default xml namespace"
	^ self usesNamespaces! !

!XMLElement methodsFor: '*XPath-Core-private' stamp: 'monty 10/10/2015 02:55'!
namespaceAxisSelect: aNamespaceNodeTestBlock into: aNodeSet
	self hasNamespaceNodes
		ifTrue: [
			self namespaceNodesDo: [:each |
				(aNamespaceNodeTestBlock value: each)
					ifTrue: [aNodeSet addLast: each]]].
	^ aNodeSet.! !

!XMLElement methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/26/2015 22:07'!
namespaceNodes
	| namespaceNodes |

	namespaceNodes := self newListForSelect.
	self namespaceNodesDo: [:each | namespaceNodes addLast: each].
	^ namespaceNodes.! !

!XMLElement methodsFor: '*XPath-Core-enumerating' stamp: 'monty 3/26/2015 23:29'!
namespaceNodesDo: aBlock
	"every element has a node for the default xml namespace.
	if it isn't explicitly defined, then it's first in order"
	self usesNamespaces
		ifFalse: [^ self].

	(self hasNamespaces
		and: [self namespaceScope includesPrefix: 'xml'])
		ifFalse: [aBlock value: (XPathNamespaceNode withXMLNamespaceOnElement: self)].

	self hasNamespaces
		ifTrue: [
			self namespaceScope prefixesAndURIsDo: [:prefix :uri |
				aBlock value:
					(XPathNamespaceNode
						element: self
						name: prefix
						uri: uri)]].! !

!XMLAttribute methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLAttribute methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self value! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 4/1/2016 00:56'!
expandedName
	^ self localName expandWithXMLNamespaceURI: self namespaceURI! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 2/28/2015 14:13'!
hasNamespaceURI
	^ false! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:58'!
hasPrefix
	^ false! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 14:13'!
localName
	^ self name! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 13:21'!
name
	^ self target! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 13:21'!
namespaceURI
	"The spec says the namespace URI part of a PI expanded name is null"
	^ ''! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 14:05'!
prefix
	^ ''! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self data! !

XPathNodeTestParser initialize!

XPathAxis initialize!

XPathContext initialize!

XPath initialize!
